;	nolist	
	page	124

; General application
	opt	nohdr	; no listing header
;	opt	mu	; memory utilization report
;	opt	mi	; macros search in include Dir
	opt	nosms	; don't preserve memory space for SET
	opt	noidw	; no stall warnings	
	opt	mc	; display macro calls
	opt	nomd	; don't print macro defs
	opt	nocl	; don't print conditional asm
	opt	mex	; print macro expansions
	opt	nou	; don't print skiped conditional asm
	opt	ur	; show unresolved refs
	opt	dld	; allow directives within do loops
	opt	cex	; expand constants
;	opt	cc	; count cycles

interruptible	set	1

pi	set	3.14159265359
fext	equ	19660800.
pll_num set	10
pll_den	set	3
debugger	 set	$4100
fdsp 	set	19660800.*@cvf(pll_num)/@cvf(pll_den)

; Fdsp = 19.6608MHz * pll_num / pll_den
;  num,den:
;	25,3	; 163.8400 M
;	16,2	; 157.2864 M
;	23,3	; 150.7328 M
;--->   dspfreq higher limit for proper ALU operation
;	22,3	; 144.1792 M
;	14,2	; 137.6256 M
;	20,3	; 131.0720 M
;	18,3	; 117.9648 M
;	35,6	; 114.6880 M
;	17,3	; 111.4112 M
;	11,2	; 108.1344 M
;	16,3	; 104.8576 M		
;	31,6	; 101.5808 M
;	15,3	;  98.3040 M
;	25,6	;  81.9200 M
;-->    dspfreq higher limit for proper DMA operation
;-->	10,3	;  65.5360 M 
;	5,3	;  32.7680 M
;	5,6	;  16.3840 M
;	2,6	;   6.5536 M
;	1,12	;   1.6384 M

;	list
	org	x:0		; Default origin in x: field
	org	y:0		; Default origin in y: field

	org	p:0		; Reset vector
	jmp	start

	if	interruptible
	org	p:$52
	jsr	<scirxerr
	endif	; 
				
	org	p:$100		; Start of main program
start	jsr	inits		; Initialize Hardware


; -------------------- USER PROGRAM --------------------------------

