; Toc Timer stop and display time
; Utility for H/W measuring effective execution time
; Tic = start 
; Toc = stop and display result  

toc	macro	timer

	if	timer==0 
tcsr	set	tcsr0
tlr	set	tlr0
tcr	set	tcr0
	endif

	if	timer==1 
tcsr	set	tcsr1
tlr	set	tlr1
tcr	set	tcr1
	endif

	if	timer==2 
tcsr	set	tcsr2
tlr	set	tlr2
tcr	set	tcr2
	endif

;	org	x:
;tictoc_time	ds	1

	org	p:
	nop
	nop
	nop
	nop
	move	x:tcr,a
	move	x:tic_time,x0
	sub	x0,a
	asl	a
	sub	#8,a
;	move	a,x:tictoc_time

	move	#msgtic,r0
	move	#-1,m0
	bsr	msg

	move	#tabp10,r0

outuint
	do	#7,oi5
oi2	move	#>'0',b	
	movem	p:(r0)+,x0
oi3	cmp	x0,a
	blt	<oi4
	sub	x0,a
	add	#1,b
	bra	<oi3
oi4	bsr	outch
	nop
oi5
	move	#msgtoc,r0
	bsr	msg
	jmp	debugger

outch	brclr	#1,x:ssr,outch
	move	b1,x:stxl
	rts	

msg	movem	p:(r0)+,b
	tst	b
	beq	msg1
	bsr	outch
	bra	msg
msg1	rts

tabp10	dc	1000000,100000,10000,1000,100,10,1
		opt	nops
msgtic	dc	10,13
		dc	'Tic -> Toc time: '
		dc	0
msgtoc	dc	' Cycles'
		dc	10,13,0

	endm


