;; ENCODE
;; GF(2) encoder
;; Bool line matrix encode to bool line matrix
;; Input= address in table (left justified)
;; Output= table[input] 

encode	macro	name
	move	#name\_table,n0
	lda	name\_in
	lsr	#24-name\_in_col,a
	move	a1,r0
	move	#-1,m0
 if	@msp(name\_table)==1
	move	x:(r0+n0),a
 else 
  if	@msp(name\_table)==2
	move	y:(r0+n0),a
  else
   if	@msp(name\_table)==3
	move	l:(r0+n0),a
   else
    if @msp(name\_mem)==4
	move	p:(r0+n0),a
    else 
	fail	'Memory field not defined'
    endif
   endif
  endif
 endif
	sta	name
	u	r0
	U	n0
	u	a
	endm
