;; Blinking core activity LED 
;; CORE0 
;; E2PROM signals (DSP dir):
;; PE6=CS\(out)  PE7=SO(in)  PE8=SI(out)  PE9=SCK(out)
;; LED on PE8
;; Directions 0000 0000 0000 0011 0100 0000
;;
;; CORE1
;; E2PROM signals (DSP dir):
;; PC6_1=CS\(out)  PC7_1=SO(in)  PC8_1=SI(out)  PC9_1=SCK(out)
;; LED on PC8_1
;; Directions 0000 0000 0000 0011 0100 0000


blinkled	macro	name,period
name\_dir	set	$000340
name\_orm	set	$000100
name\_andm	set	$FFFEFF

 if core==0
	section 	inits
val_pcre0	set	val_pcre0&name\_andm
val_prre0	set	val_prre0|name\_orm
val_pdre0	set	val_pdre0|$000040
	endsec
 else
	section 	inits
val_pcrc1	set	val_pcrc1&name\_andm
val_prrc1	set	val_prrc1|name\_orm
val_pdrc1	set	val_pdrc1|$000040
	endsec
 endif
	var		name\_acc
name\_d		set	@frc(4./@cvf(period))
	org		p:     		
	lda		name\_acc
	add		#>name\_d,a
	sta1		name\_acc
	bec		name\_1
 if core==0
	move		Y:PDRE,a
	eor		#>name\_orm,a
	move		a1,Y:PDRE
 else
	move		x:PDRC,a
	eor		#>name\_orm,a
	move		a1,x:PDRC
 endif
name\_1
 	u	a
	endm
