;; Initialization for DSP56720 card

init	macro

	org	p:
;	reset
	move	#0,sp
	nop
	nop
	jsr	init


	section	inits 
	global	init
	org	p:
init
 if core==0
val_pdre0	set		val_pdre0|$000040	;; CS EEPROM UP 
val_iprp0 	set		val_iprp0&$fffff3|$00000C
val_sr0		set		val_sr0&$fffcff
 else
val_pdrc1 	set 		val_pdrc1|$000040 ;; idem 
val_iprp1 	set		val_iprp1&$fffff3|$00000C
val_sr1		set		val_sr1&$fffcff
 endif
	move		#$2B60BF,a1
	move		a1,x:$FFFF7D	; (PTCL)
	movec	#$00BF80,ep	
	bset		#16,omr		; y: extended stack
	bset		#20,omr		; enable E-stack
	movep	#$000001,x:HCKR0	; cpha=1 autorise multiple I/Os avec ss\ actif
	movep	#$001028,x:HCSR0	; (reset)
	movep	#$001029,x:HCSR0	; ena slave 24b Rie-Fifo-not-empty 0001 0000 0010 1001
	clr	a
	sta	dspstatus
	sta	pcstatus
	move	#2,a1
	sta1	dbg_status
	flagclr	spi_waiad
	flagclr	spi_waidat
	flagclr	spi_wainb

	endsec




	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 13/03/2012

