;; module sdr_tx_27MHz
;; SDA PC7_1 SCL PC8_1

	include 'rfdo.asm'
	if !@mac(i2c_fpga)
	include 'i2c_fpga.asm'
	endif	
	i2c_fpga
  if !@mac(fpga_aff)
	include 'fpga_aff.asm'
  endif	

sdr_tx	macro	rf,fosc

	section	strings	global
	org	y:
	opt	nops
;	str	aff_str1,'SDR TX RF='
;	str	aff_str1,"rf"
aff_str1	dc	'SDR TX RF='++"rf"
aff_str1_lng	set *-aff_str1
;	str	aff_str2,'Ftx='
;	str	aff_str2,"fosc"
;	str	aff_str2,' Hz'
aff_str2	dc	'Ftx='++"fosc"++'Hz'
aff_str2_lng	set	*-aff_str2
	endsec

  section data global
  org y:
sdr_tx_ctrl  dcb   $02,$48,$00
  endsec

	rfdco 4*fosc	

	
	

	org p:
	section  inits		

wait_pb:
  rep   #100
  nop
  move  x:status_pb,a1
  brclr #7,a1,wait_pb


  move	  #sdr_tx_ctrl,r0
  move    #$01,r1  
  move    r1,y:(r0+2)   
	jsr	pcf8574_w


;;si570
	move	#>$AA8910,r0
	jsr	si_write
	move	#60000,n0
	rep	n0
	nop
	move	#>si_r7,r0		;;#>$AA0718,a1
	jsr	si_write
	move	#>si_r8,r0		;;#>$AA08C2,a1
	jsr	si_write
	move	#>si_r9,r0		;;#>$AA09BC,a1
	jsr	si_write
	move	#>si_r10,r0		;;#>$AA0A01,a1
	jsr	si_write
	move	#>si_r11,r0		;;#>$AA0B1E,a1
	jsr	si_write
	move	#>si_r12,r0		;;#>$AA0CB8,a1
	jsr	si_write
	move	#>$AA8900,r0	;; Unfreeze DCO
	jsr	si_write		
	move	#30000,n0		;; Newfreq
	rep	n0
	nop
	move	#>$AA8740,r0
	jsr	si_write
  
  move	  #sdr_tx_ctrl,r0
   if ("rf"=='off')	
  move    #$00,r1
  move    r1,y:(r0+2)
	endif
	if ("rf"=='on')
	move	  #$07,r1    
  	move    r1,y:(r0+2)
	endif
	
	jsr	pcf8574_w

wait_si_cnf:  
  nop
  move	#100,n0
	rep	n0
	nop
  move  x:status_pb,a1
  brclr  #9,a1,wait_si_cnf

	fpga_aff	aff_str1,aff_str2 
	endsec

	org	p:
;

	u	a
	u	r0
	u	n0
	endm

