;; module sdr_tx_27MHz
;; sur core 0 I2c0

;;	include 'i2c0.asm'

fpga_base	set	$040000
status_i2c0	set 	fpga_base+$15
ctrl_i2c0	set	fpga_base+$17
tx_i2c0	set   fpga_base+$18

f_tx	macro	rf,fosc

freq_fract  set @cvf(fosc/30.0e6)
f_fract     set @frc(freq_fract)

	org p:
	section  inits		



  move #>f_fract,a1
  move  a1,x:tx_i2c0
  move #$824346,a1
  move 	a1,x:ctrl_i2c0
 
 wait_freq:
  rep   #1000
  nop
  move  x:status_i2c0,a1
  brset #5,a1,wait_freq  

  move  #$000100,a1
  move 	a1,x:ctrl_i2c0

  move #10000000,r0
  rep r0
  nop

  if ("rf"=='off')	
  move    #$00,a1
  endif
	if ("rf"=='on')
	move	  #$01,a1    
  endif

  move  a1,x:tx_i2c0	
  
  move #$82234D,a1
  move 	a1,x:ctrl_i2c0  

wait_pb1:
  rep   #1000
  nop
  move  x:status_i2c0,a1
  brset #5,a1,wait_pb1	

  move  #$000100,a1
  move 	a1,x:ctrl_i2c0
  
  move #10000000,r0
  rep r0
  nop
 ; rep #1000
 ; nop  
  
	endsec

	endm

