;; module sdr_rx_vhf
;; SDA PC7_1 SCL PC8_1
;; inversion LF et 27 MHz selecteur

  if core==0
    fail "must be in core 1"
  endif
	include 'rfdo.asm'
	if !@mac(i2c_fpga)
	include 'i2c_fpga.asm'
  i2c_fpga
	endif	
  if !@mac(fpga_aff)
	include 'fpga_aff.asm'
  endif
	
sdr_rx_vhf	macro name,fosc

;;	var	name\ctrl_port
	
	str	aff_str1,'SDR RX VHF'
	str	aff_str2,'Frx='
	str	aff_str2,"fosc"
	str	aff_str2,' Hz'

  section data global
  org y:
sdr_rx_ctrl  dcb   $02,$44,$F8
  endsec	


	rfdco 2*fosc	
      if @mac(i2c_sdr) 
	i2c_sdr	
      endif


	org p:
	section  inits		
wait_pb:
  rep   #100
  nop
  move  x:status_pb,a1
  brclr #7,a1,wait_pb
  
  move #sdr_rx_ctrl,r0
	
;;	STA1	name\ctrl_port
	jsr	pcf8574_w

	

;;si570
	move	#>$AA8910,r0
	jsr	si_write
	move	#30000,m0
	rep	m0
	nop
	move	#>si_r7,r0		;;#>$AA0718,a1
	jsr	si_write
	move	#>si_r8,r0		;;#>$AA08C2,a1
	jsr	si_write
	move	#>si_r9,r0		;;#>$AA09BC,a1
	jsr	si_write
	move	#>si_r10,r0		;;#>$AA0A01,a1
	jsr	si_write
	move	#>si_r11,r0		;;#>$AA0B1E,a1
	jsr	si_write
	move	#>si_r12,r0		;;#>$AA0CB8,a1
	jsr	si_write
	move	#>$AA8900,r0	;; Unfreeze DCO
	jsr	si_write	
	move	#30000,m0		;; Newfreq
	rep	m0
	nop
	move	#>$AA8740,r0
	jsr	si_write
wait_si_cnf:  
  nop
  move	#100,m0
	rep	m0
	nop
  move  x:status_pb,a1
  brclr  #9,a1,wait_si_cnf

	endsec
	
	fpga_aff	aff_str1,aff_str2	

	endm