;; Real to integer conversion          x= [-1.0 .. +1.0[   y = [min ... max[
;; Syntax: 	fitf2i	name,min,max
;; where min is the integer output for a -1.0 input, and max, for a +1.0 theoretical input
;; Input: name_in (real)	Output: name (integer)
;;

fitf2i	macro	name,min,max

	if	@cnt()==2
	fitf2i	name,min,$7fffff
	endif
	if	@cnt()==1
	fitf2i	name,0,$7fffff
	endif
	if	@cnt()==0
	fail	'fitf2i	name,min,max'
	else
	
	org	p:
name\_exe
	cc_rst
	move	#>(max+min)/2,a
	ldx0	name\_in
	macri	#>(max-min)/2,x0,a
	sta	name
	cc_ac	1

; endsec

	u	a
	u	x
	
	endif
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


