;; Integer to real conversion   x = [min ... max[  -->  y = [-1.0 .. +1.0[   
;; Syntax: 	fiti2f	name,min,max                    y = [2/(M-m)]*x + (M+m)/(m-M)
;; where min is the integer input which gives a -1.0 output, and max the input which gives +1.0
;; Input: name_in (integer)  Output: name (real)         
;;

fiti2f	macro	name,min,max
	if	@cnt()==2
	fiti2f	name,min,$7fffff
	endif
	if	@cnt()==1
	fiti2f	name,0,$7fffff
	endif
	if	@cnt()==0
	fail	'Syntax:	fiti2f 	name,min,max'
	else
	
name\_g	set	1.0/@cvf(max-min)
	
	org	p:
name\_exe

 if	min==0
	ldx0	name\_in
 else
	lda	name\_in
	move	#>min,x0
	sub	x0,a
	move	a,x0
 endif
	move	#>name\_g,x1
	mpy	x0,x1,a
	asl	#23,a,a
	sub	#0.5,a
	asl	a
	sta	name

	u	a
	u	x
	
	
	endif
	
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


