;; ArcTangent function y=(1/pi)Atan(x), defined for x inside  [-1 ... +1[, thus  y = [-0.25 ..+0.25[
;; Syntax: 	f_atan	name,points
;; Points defines the 0..pi/4 table resolution (15 is generally enough) 
;; Input: name_in, real       Output: name, real
;; 

f_atan	macro	name,points

	if	!@def(tbl_atan)
	section data global
	org	y:
tbl_atan

atan_pt	set	0.0

; 0..1 arctg table here
	nolist
	dup	points-1
	dc	@atn(atan_pt)/pi
atan_pt	set	atan_pt+1./@cvf(points-1)
	endm
	dc	0.25
tbl_atan_segmts set	points-1
tbl_atan_size set points
	endsec
	list
	endif


	org	p:
	cc_rst
name\_exe

	org	p:
	lda	name\_in
	abs	a	a,b
	regin
	dbgdisa
name\_t_accu	set	1
	tblrd	name\_t,tbl_atan,u
	dbgena
	tst	b
	neg	a	iflt
	sta	name

	u	a
	u	b
	u	r0
	u	x
	varin

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


