;; Gaussian function  y = 2^-kx
;; Syntax:	f_gauss	name,k,points
;; Choose k=pi/ln(2)=4.532 to get the normalized exp-(pi*x); "points" define table resolution 
;; Input: name_in    Output: name

f_gauss	macro	name,k,points
	cn	name\_in,name\_s_in
	cn	name\_s,name\_e_in
	cn	name\_e,name

	dbgdisa
	square	name\_s
	f_expabs 	name\_e,k,points
	dbgena

	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


