;; Sine-cosine complex generator  y(k) = exp(j*2*pi*freq*k/Fs)
;; Syntax:	g_sincos   name,freq,abs|rel
;; abs: frequency in Hz  rel: frequency relative to Fs/2 
;; Outputs: name (complex) or name_re, name_im (real); name_phi (phase) 
;; Opt. input: name_freq = dco input [-1..+1[ --> -Fs/2..Fs/2  (freq overwritten)
 
g_sincos macro	name,freq,ar

	if		@def(name\_freq)
	cn		name\_freq,name\_phi_freq
	endif
	cn		name\_phi,name\_fsc_in	
	cnc		name\_fsc,name

	dbgdisa

	g_saw		name\_phi,freq,ar
	f_sincos 	name\_fsc,127

	dbgena

	dbgw		G_SINCOS
	dbg		name\_freq
	dbg		name\_re
	dbg		name\_im


	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


