;; Integrator with input gain    y(k) = y(k-1) + g * x(k)
;; Syntax:	integ	name,gain
;; Where gain represents the step per sample when x(k) = 1 (maximal slope = gain * Fs)
;; Input: name_in   Optional input: name_gain   Output: name (single or double precision)


integ	macro	name,gain

	coef	name\_gain,gain
	org	p:

 if @def(name\_clr_b)
	jnot	name\_clr,name\1
	clr	a
	sta	name
	bra	<name\2
name\1
 endif
	lda	name
	ldx0	name\_in
	ldx1	name\_gain
	if	@msp(name)==3
	mac	x0,x1,a
	else
	macr	x0,x1,a
	endif
	sta	name
name\2
	u	a
	u	x

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


