;; Magnitude function. If x real then y=|x|. If x complex, y = sqroot(xre+xim)
;; Syntax: 	magn	name
;;
;; Input:	name_in (real OR complex)     Output:	name (real)


 
magn		macro	name

	org	p:

	cc_rst
	if	@def(name\_in_im)
	ldx0	name\_in_re
	ldx1	name\_in_im
	mpy	x0,x0,a		x1,x0
	mac	x0,x0,a
	sqrt	24
	else
	lda	name\_in
	abs	a
	endif
	sta	name
	u	a
	u	b
	u	x
	u	y

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


