;; Sum of matrixes MA + MB --> MC
;; Syntax:	matadd	name
;; inputs name_in1  name_in2
;; output name
;;



matsum	macro	name
;; Test connections and dimensions
 if @def(name\_in1)
  if @def(name\_in2)
   if @def(name)
    if name\_in1_lin==name\_in2_lin
     if name\_in1_col==name\_in2_col
      if name\_lin==name\_in1_lin
       if name\_col==name\_in1_col

;; Everything ok, create exec code  (Nlin,Mcol) + (Nlin,Mcol) --> (Nlin,Mcol)
		org	p:
		move		#name\_in1,r0
		move		#name\_in2,r4
		move		#name,r1
		move		#-1,m0
		move		m0,m1
		move		m0,m4

		do		#(name\_lin*name\_col),name\_1
 if	@msp(name\_in1)==1
  if	@msp(name\_in2)==1
		move		x:(r0)+,a
		move		x:(r4)+,x0
  else
		move		x:(r0)+,x0	y:(r4)+,a
  endif
 else
  if	@msp(name\_in2)==1
		move		x:(r4)+,x0	y:(r0)+,a
  else
		move		y:(r0)+,a	
		move		y:(r4)+,x0
  endif
 endif
		add		x0,a 
 if		@msp(name)==1	
		move		a,x:(r1)+
 else
		move		a,y:(r1)+
 endif
name\_1

;; Else, error messages
      else
	fail "name",' output columns should be equal to ',"name",'_in1 columns !'
      endif   
      else
	fail "name",' output lines should be equal to ',"name",'_in1 lines !'
      endif 
     else
	fail "name",'_in1 input columns should be equal to ',"name",'_in2 columns !'
     endif 
    else
	fail "name",'_in1 lines should be equal to ',"name",'_in2 lines !'
    endif 
   else
	fail	'Output matrix ',"name",' is not connected !'
   endif
  else
	fail	'Input matrix  2 ',"name",'_in2 is not connected !'
  endif
 else
	fail	'Input matrix  1 ',"name",'_in1 is not connected !'
 endif


	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


