;; Complex multiply with conjugate    
;; Syntax:	mulcc	name
;; if name_in1=a+jb, name_in2=c+jd  
;; then: name = (a+jb)*(c-jd) = (ac+bd) + j(bc-ad)
;;

mulcc	macro	name
	if	rgin
	move	a,x0
	move	b,x1
	else
	ldx0	name\_in1_re
	ldx1	name\_in1_im
	endif

	ldy0	name\_in2_re
	ldy1	name\_in2_im

	mpy	x0,y0,a
	macr	x1,y1,a
	mpy	-x0,y1,b
	macr	x1,y0,b

	sta	name\_re
	stb	name\_im


	u	x
	u	y
	u	a
	u	b
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


