;; Complex oscillator z(k) = exp(j*2*pi*freq*k*T)
;; Syntax:	oscpq	name,freq,abs|rel
;; where freq is expressed in Hertz if "abs" and as a fraction of Fs/2 if "rel"
;; Outputs: name (complex),  name_re, name_im (real)


oscpq	macro	name,freq,ar


	if	("ar"=='abs')|("ar"=='Hz')
	varc	name\_vect,1.00000,2*freq/actual_fs,p
	else
	varc	name\_vect,1.000001,freq,p
	endif

	cn	name\_vect,name\_in1
	cn	name,name\_in2

	org	p:
 dbgdisa
	mult	name
 dbgena

	dbgw	OSCPQ
	dbg	name\_re
	dbg	name\_im

	section	inits
	move	#-1.0,a
	sta	name\_im
	clr	a
	sta	name\_re
	endsec	

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


