;; Get peak amplitude of abs input
;; Syntax: 	ampl	name
;; Output value updated at each zero crossing
;; Input name_in   Output: name
;;

peak	macro	name
	var	name\_max,0
	var	name\_last,0

	org	p:
	lda	name\_in
	abs	a		x:name\_last,x0	a,y0
	ldb	name\_max
	max	a,b		y0,x:name\_last
	stb	name\_max
	mpy	x0,y0,a	
	bgt	name\_1
	stb	name
	clr	b
name\_1 		
	stb	name\_max

	u	a
	u	b
	u	x
	u	y

	dbgw	PEAK
	dbg	name\_in
	dbg	name
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


