;; Slope limiter for attenuating spikes due to EMI
;; Syntax:	slopelim	name,slope[,slopeneg]
;; Where slope = maximum increment per sample, slopeneg = maximum decrement if different from increment
;; Input:name_in	Output: name

slopelim	macro	name,slope,slope_n

;	var	name,0
	coef	name\_dp,slope

	if	@cnt()==3
	coef	name\_dn,slope_n
	endif

	org	p:
name\_exe

	if	!rgin
	lda	name\_in
	endif

	ldx0	name\_dp
	ldb	name
	add	x0,b

	cmp	b,a
	bgt	<name\_ex1

	if	@cnt()==3
	ldx0	name\_dn
	endif
	ldb	name	
	sub	x0,b

	cmp	b,a
	bge	name\_ex2
name\_ex1
	tfr	b,a
name\_ex2
	sta	name


	u	a
	u	b
	u	x


	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


