;; Software periodic timer defined by a frequency. Sets a flag "name" at rate freq. 
;; Syntax:	timerf	name,freq,Hz|*Fs/2
;; 
;; Note: If freq is high, jitter will occur, but the average generated freqency will be exact 
;;



timerf		macro	name,freq,unit

	var	name\_acc,0

	section	inits
	org	p:
	move	#-1.0,a
	sta	name\_acc
	flagclr	name
	endsec
	
	org	p:
name\_exe

	if	("unit"=='Hz')||("unit"=='abs')
	coef	name\_freq,freq*2.0/actual_fs
	else
	coef	name\_freq,freq
	endif
	flagrst	name
	lda	name\_freq
	ldx0	name\_acc
	add	x0,a
	bec	<name\_1
	flagset	name
name\_1
	move	a1,a
	sta	name\_acc

	u	a
	u	x
   endm				
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


