;; Software periodic timer. 
;; Syntax:	timerp	name,period,unit
;; Sets a flag in the variable "flag" every 'period' sampling periods.
;; Serves usually as counter to get submultiple sampling frequency
;;


timerp		macro	name,period,unit

 if ("unit"=='s')||("unit"=='sec')||("unit"=='abs')
	var	name\_cntr,@cvi(period*actual_fs)
	coef	name\_cnt,@cvi(period*actual_fs)	
 else
  if ("unit"=='ms')||("unit"=='millisec')
	var	name\_cntr,@cvi(0.01*period*actual_fs)
	coef	name\_cnt,@cvi(0.01*period*actual_fs)	
  else 
   if ("unit"=='s')||("unit"=='microsec')
	var	name\_cntr,@cvi(1E-6*period*actual_fs)
	coef	name\_cnt,@cvi(1E-6*period*actual_fs)	
   else
	var	name\_cntr,period
	coef	name\_cnt,period
   endif
  endif
 endif


		org	p:
exec_\name
		flagrst	name	
		lda		name\_cntr
		sub		#1,a
		bgt		<name\_1
		flagset	name
		lda		name\_cnt
name\_1	sta		name\_cntr

		section		inits
		org	p:
		lda		name\_cnt
		sta		name\_cntr
		flagclr	name
		endsec


		u	a

   endm				

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


