;; 2nd order bandpass



bp2	macro	name,freq,q,unit
 if "unit"=='Hz'
name\_omega	set	2*pi*freq/actual_fs
name\_eps	set	pi*freq/(q*actual_fs)
 else
  if "unit"=='Fs/2'
name\_omega	set	pi*freq
name\_eps	set	pi*freq/(q*2)  
  else
   if "unit"=='Fs'
name\_omega	set	2*pi*freq
name\_eps	set	pi*freq/q
   else
name\_omega	set	2*pi*freq/actual_fs
name\_eps	set	pi*freq/(q*actual_fs)
   endif
  endif
 endif

name\_r	set	1-name\_eps

	var	name\_d1,0
	var	name\_d2,0
	var	name\_d3,0

	coef	name\_epsi,0.5*name\_eps
	coef	name\_a1,name\_r*@cos(name\_omega) ;; NB Coeffs/2 
	coef	name\_a2,-0.5*name\_r*name\_r

	org	p:

	move	#name\_d1,r0		; champ x
	move	#-1,m0
	move	#name\_epsi,r4			; champ y
	move	m0,m4
	ldx0	name\_in	
	ldy1	name
 	move				y:(r4)+,y0		  	; y0= b0	
 	mpy	x0,y0,a		x:(r0),x1		 	; a=b0.xk  x1 = xk-1 
 	move				x0,x:(r0)+		   	; new xk-1
 	move				x:(r0),x0			; x0=xk-2  y0=-b2  
 	mac	-x0,y0,a		x1,x:(r0)+	y:(r4)+,y0 	; a+= b2.xk-2 , y0=a1, new xk-2
 	mac	y0,y1,a		x:(r0),x0	y:(r4)+,y0 	; a+= a1.yk-1  x0=yk-2 y0=a2
 	mac	x0,y0,a		y1,x:(r0)		  	; a+= a2.yk-2  new yk-2
 	asl	a
	sta	name

	u	a
	u	x
	u	y
	u	r0
	u	r4
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


