;; Codeur 
;; Fait partie du codage RDS 


chkwd_coder	macro	name
	var	name\_sr,0
	var	name\_cw,0
	var	name\_cnt,0
	jnot	name\_ck,name\_end	; exec uniquement sur clock
	flagrst name\_req 
	jnot	name\_dck,name\_0		; si req: nouveau bloc: sr = data 16b ; cw (10b) =0 Compteur=0
	lda	name\_data
	sta1	name\_sr
	clr	a
	sta	name\_cw
	sta	name\_cnt	
name\_0
	lda	name\_cnt
	add	#1,a
	sta	name\_cnt
	cmp	#17,a
	bge	name\_1			; si cnt >16 bits, partie crc 
	move	#>$6E4000,x0 		; coeffs polynomiaux pour sr et cw justifis  g
	lda	name\_cw
	ldx1	name\_sr
	eor	x1,a	a1,b			; B= cw
	move	a1,x1				; x1[23] = cw[9] xor sr[15]
	lsl	b				; dcaler cw  G;
	btst	#23,x1
	eor	x0,b	ifcs			; si x1[23] alors cw ^= x0 
	stb1	name\_cw			;

	ldb	name\_sr
	lsl	b	b1,a1 		; dcaler sr  G ; a1 = sr non dcal
	stb1	name\_sr

	bra	<name\_5

name\_1					; partie CRC:
	bne	<name\_2			; si 1er bit, cw = xor de cw avec offset
	ldb	name\_cw
	ldx0	name\_offset
	eor	x0,b
	bra	<name\_4
name\_2
	cmp	#26,a				; si dernier bit, req = True
	bne	<name\_3
	flagset	name\_req
name\_3
	ldb	name\_cw
name\_4
	lsl	b	b1,a1			; dcaler cw  G de 1 pos ; a1 = cw non dcal
	stb1 	name\_cw			; 
name\_5
	move	a1,a				; extension du signe de a1 
	bchg	#6,a2				; saturer  +/- 1
	sta	name
name\_end

	u	a
	u	b
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


