;; DIFFCOD8X3 octal 3 bit differential coder 
;; for i=0 to 7 do out[i] = out[i]+in[i] mod 8 

diffcod8x3	macro	name
 if @def(name\_rdy_b)
	flagrst	name\_rdy
 endif

	jnot	name\_ck,name\_1
	ldy0	name\_in
	ldy1	name
	move	#>7,x0

	do	#8,name\_0
	move	x1,a
	lsl	#3,a
	move	a1,x1

	clr	a 
	move	y0,a0	
	asl	#3,a,a
	clr	b	a0,y0
	move	a1,a

	move	y1,b0
	asl	#3,b,b
	move	b0,y1
	move	b1,b

	add	b,a
	and	x0,a
	or	x1,a
	move	a1,x1
name\_0
	nop 
	sta1	name
	flagset	name\_rdy
name\_1
	u	a
	u	b
	u	x
	u	y
	endm 


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use




