;; Signed fractional Division      name = (name_num / name_den) 
;; Syntax: 	divide	name
;; Attention !!! |name_num| must be < to |name_den|. If name_den is constant, use GAIN 
;; Inputs:	name_num , name_den	Output:	name

;; JMO Rev 15/05/02
;; div.bmp

divide	macro	name

	org	p:
name\_exe
	cc_rst

	ldb	name\_den
	clb	b,a 
	move	a1,x0
	lda	name\_num
	normf	x0,b
	normf	x0,a 

 dbgdisa
	flagclr	negdiv
	tst	a
	bpl	name\_0
	abs	a
	flagset	negdiv
name\_0	tst	b
	bpl	name\_1
	abs	b
	flagtog	negdiv

name\_1	move	b,x0
	andi	#$fe,ccr
	do	#24,name\_2
	div	x0,a
name\_2
	move	a0,a
	jnf	negdiv,name\_3 
	neg	a
name\_3	sta	name
	cc_ac	1
 dbgena
	dbgw	DIVIDE
	dbg	name\_num
	dbg	name\_den
	dbg	name


	u	a
	u	b
	u	x


	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


