;; ASCII source  Generates ASCII codes from a Text file on Boolean request
;; Syntax: g_ascii	name,file
;; Boolean: Input name_ck= request ascii ;  Output name_rdy = new ascii present on output 
;; Output: name: 8 bit ASCII code left justified in 24 bit word
;;

g_ascii	macro	name,file
	section	text global
	org	p:
name\_text
	include	"file"
name\_end equ	*
	endsec

	var	name\_sr,0
	var	name\_ptr,name\_text

 if @def(name\_rdy_b)
	flagrst	name\_rdy
 endif
	jnot	name\_ck,name\_2
	lda	name\_sr
	tst	a
	bne	name\_1
	ldr0	name\_ptr
	move	#-1,m0
	nop
 	move	p:(r0)+,a
	move	r0,b
	cmp	#>name\_end,b
	blt	<name\_0
	move	#name\_text,r0
name\_0
	str0	name\_ptr			
name\_1
	asl	#8,a,b
	and	#$FF0000,a
	sta1	name
	stb1	name\_sr
 if @def(name\_rdy_b)
	flagset	name\_rdy
 endif
name\_2

	u	a
	u	b
	u	r1
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


