;; Get last N data from circular buffer filled under IRQ 
;; N is defined by output size   

getoverlap macro name
 if @def(name\_in_im)
	bufm name\_buf,l,name\_size+10
 else
	bufm name\_buf,y,name\_size+10
 endif
	org	p:
	move		y:r_\name\_pt,r0
	move		#name\_size+9,m0
	move		#name\_size,n0
	move		#name+name\_size-1,r4
	move		#-1,m4
	move		#0,x0
	do		n0,name\_1
 if @msp(name\_buf)==3
	move		l:(r0)-,x
 else
	move		y:(r0)-,x1
 endif
 if @msp(name)==1
	move		x1,x:(r4)-
 endif
 if @msp(name)==2
	move		x1,y:(r4)-
 endif
 if @msp(name)==3
	move		x,l:(r4)-
 endif
name\_1


	section		irq
	ptr			name\_pt,1,name\_buf,name\_size+9
 if @def(name\_in_im)
	ldx1		name\_in_re
	ldx0		name\_in_im
	move		x,l:(r1)+
 else
	ldx0		name\_in
	move		x0,y:(r1)+
 endif
	ptru		name\_pt

	u	r0
	u	r1
	u	r2
	u	r3
	u	x
	endsec

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


