;; Hardware Timer 

hwtimer	macro	name,nr,count

	section	inits
	movep	#$1,x:tlr\nr
	movep	#count,x:tcpr\nr
	movep	#$300205,x:tcsr\nr

 if core==0
val_iprp0	set	val_iprp0|$000300
val_sr0	set	val_sr0&$fffcff
 else
val_iprp1	set	val_iprp1|$000300
val_sr1	set	val_sr1&$fffcff
 endif

	endsec

	section	vectors	global
 if nr==0
	org	p:$54
 endif
 if nr==1
	org	p:$58
 endif
 if nr==2
	org	p:$5C
 endif
	jsr	irq_timer\nr
	endsec

	section	irq
	global irq_timer\nr
	org	p:
irq_timer\nr
	flagset	name
	movep	#$300205,x:tcsr\nr
	rti
	endsec

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


