; Unmap
; input = a pair of coordinates from one constellation point
; output the corresponding code
; The whole table is scanned for searching the minimum distance

identify	macro	name,bits,table

  	if	!@def(table)
	section	data global
	org	y:
table
	include	"table"++'.asm'
	endsec
 	endif

	org	p:
	jcnf	name\_ck,name\_2
	move	#table,r0
	move	#>$7FFFFF,y0
	ldx0	name\_in_re
	ldx1	name\_in_im
	do	#1<<bits,name\_1
	move	y:(r0)+,a
	sub	x0,a
	abs	a	y:(r0)+,b
	sub	x1,b
	abs	b	
	add	a,b	y0,a
	cmp	y0,b
	tlt	b,a	r0,r4
	move	a,y0
name\_1 
	move	r4,a
	sub	#table+2,a
	lsr	a
	asr	#bits,a,a
	sta0	name
	flagset	name\_ready
name\_2

	dbgw	UNMAP
	dbg	name\_in_re
	dbg	name\_in_im
	dbgi	name

	endm

	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


