;; 8 point Inverse FFT

ifft8	macro	name,scl
 if !@def(w81)	
	section	data global
	org	l:
w81	dc	@lng(@frc(@sqt(2.)/2.),-@frc(@sqt(2.)/2.)) 
	endsec
 endif
; ifft8exec 
	move	#name,r0
	move	#0,m0
	move	#4,n0
	move	#name\_in,r1
	move	#-1,m1
	do	#8,name\_1
	move	l:(r1)+,ab
 if	"scl"=='scale'
	asr	#3,a,a
	asr	#3,b,b
 endif
	move	ab,l:(r0)+n0
name\_1
	move	#name,r0
	move	#7,m0
	move	#2,n0

	do	#4,name\_2
	move		l:(r0)+,ab	;0 - 1 
	move		l:(r0)-,y	;1 - 0 
	add	y1,a	a,x1
	add	y0,b	b,x0
	move		ab,l:(r0)+	;0 - 1
	move		x1,a
	sub	y1,a	x0,b
	sub	y0,b
	move		ab,l:(r0)+	;1 - 2 / 4 / 6 / 0
name\_2		
	move		l:(r0)+n0,ab	;0 - 2
	move		l:(r0)-n0,y	;2 - 0 
	add	y1,a	a,x1
	add	y0,b	b,x0
	move		ab,l:(r0)+n0	;0 - 2  
	move		x1,a
	sub	y1,a	x0,b
	sub	y0,b
	move		ab,l:(r0)-	;2 - 1

	move		l:(r0)+n0,ab	;1 - 3 
	move		l:(r0)-n0,y	;3 - 1 
	sub	y0,a	a,x1	;	add	y0,a	a,x1
	add	y1,b	b,x0	;	sub	y1,b	b,x0
	move		ab,l:(r0)+n0	;1 - 3
	move		x1,a
	add	y0,a	x0,b	;	sub	y0,a	x0,b
	sub	y1,b		;	add	y1,b
	move		ab,l:(r0)+	;3 - 4

	move		l:(r0)+n0,ab	;4 - 6
	move		l:(r0)-n0,y	;6 - 4 
	add	y1,a	a,x1
	add	y0,b	b,x0
	move		ab,l:(r0)+n0 	;4 - 6 
	move		x1,a
	sub	y1,a	x0,b
	sub	y0,b
	move		ab,l:(r0)-	;6 - 5

	move		l:(r0)+n0,ab	;5 - 7 
	move		l:(r0)-n0,y 	;7 - 5
	sub	y0,a	a,x1		;	add	y0,a	a,x1
	add	y1,b	b,x0		;	sub	y1,b	b,x0
	move		ab,l:(r0)+n0	;5 - 7 
	move		x1,a
	add	y0,a	x0,b		;	sub	y0,a	x0,b
	sub	y1,b			;	add	y1,b		
	move		ab,l:(r0)+	;7 - 0
; end2ndpass
	move		#4,n0
	nop	
	move		l:(r0)+n0,ab	;0 - 4 
	move		l:(r0)-n0,y 	;4 - 0
	add	y1,a	a,x1
	add	y0,b	b,x0
	move		ab,l:(r0)+n0	;0 - 4 
	move		x1,a
	sub	y1,a	x0,b
	sub	y0,b
	move		ab,l:(r0)-n0	;4 - 0
	move		(r0)+		;0 - 1

	move		l:(r0)+n0,ab	;1 - 5 
	move		l:(r0)-n0,y	;5 - 1
	move		l:w81,x 
	mac	x1,y1,a	a,r1
	mac	x0,y0,a		;	mac	-x0,y0,a
	mac	x1,y0,b	b,r2
	mac	-x0,y1,b		;	mac	x0,y1,b
	move		ab,l:(r0)+n0	;1 - 5 
	move		r1,a
	mac	-x1,y1,a	r2,b
	mac	-x0,y0,a		;	x0,y0,a
	mac	x0,y1,b 		;	-x0,y1,b
	mac	-x1,y0,b
	move		ab,l:(r0)-n0	;5 - 1
	move		(r0)+		;1 - 2

	move		l:(r0)+n0,ab	;2 - 6 
	move		l:(r0)-n0,y	;6 - 2 
	sub	y0,a	a,x1		;	add	y0,a	a,x1
	add	y1,b	b,x0		;	sub	y1,b	b,x0
	move		ab,l:(r0)+n0	;2 - 6 
	move		x1,a
	add	y0,a	x0,b		; 	sub	y0,a	x0,b
	sub	y1,b			;	add	y1,b
	move		ab,l:(r0)-n0	;6 - 2
	move		(r0)+		;2 - 3

	move		l:(r0)+n0,ab	;3 - 7
	move		l:(r0)-n0,y	;7 - 3
	move		l:w81,x 
	mac	-x1,y1,a	a,r1
	mac	x0,y0,a 		;	mac	-x0,y0,a
	mac	-x1,y0,b	b,r2
	mac	-x0,y1,b 		;	mac	x0,y1,b
	move		ab,l:(r0)+n0 ;3 - 7
	move		r1,a
	mac	x1,y1,a	r2,b
	mac	-x0,y0,a 		;	mac	x0,y0,a
	mac	x0,y1,b 		;	mac	-x0,y1,b
	mac	x1,y0,b
	move		ab,l:(r0)	;7

; fftend
	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0
	u	r1
	u	r2
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


