; PIANO sur DSP56309



kbpiano	macro 	name
; Paramtres gnraux

name\_amort		set		150. ; Cte de temps amortisst exprime en priodes


; Table des gnrateurs: 
; 1er mot = facteur complexe; 2me mot = tat complexe

			org		l:
name\_genes		dsm		20		; rserver 10 x 2 mots (tampon cyclique)

; Table des paramtres (18 notes)
; notes do do# re re# mi fa fa# sol sol# la la# si do do# re re# mi fa
; n     -9 -8  -7 -6  -5 -4 -3   -2  -1   0  1   2  3  4   5  6   7  8
			org	l:
name\_n			set	-9.

name\_facteurs
			dup	18
name\_freq		set	440*@pow(2,name\_n/12)	; frquence (gamme tempre JS Bach)
name\_tau		set	name\_amort/name\_freq			; cte de temps amort. proportionnelle  priode 
name\_alpha		set	1.-(1/(actual_fs*name\_tau))
name\_theta		set	2*pi*name\_freq/actual_fs
	dc		@lng(@frc(name\_alpha*@cos(name\_theta)),@frc(name\_alpha*@sin(name\_theta))) ; facteur complexe
name\_n			set	name\_n+1
			endm

; Touches correspondantes (sur 2 rangs dizes en haut comme sur un piano)
			org	y:
name\_touches	dc		'q','z','s','e','d','f','t','g','y','h','u','j','k','o','l','p','m',''
			org	x:
; PROGRAMME EXECUTABLE
			org		p:
			ptr		name\_pg,0,name\_genes,19,2
			move		#name\_genes,r0
			do 		#10,name\_p1		; excuter les 10 oscillateurs
			move		l:(r0)+,x		; tat
			move		l:(r0)-,y		; facteur complexe
			mpy		x1,y1,a		; produit complexe
			mac		-x0,y0,a
			mpy		x0,y1,a		a,x:(r0)
			mac		x1,y0,a
			move		a,y:(r0)+n0		; tat mis  jour, gn suivant
name\_p1
			move		#>0.1,y0
			clr		a				x:(r0)+n0,x0
			rep		#9
			mac		x0,y0,a		x:(r0)+n0,x0	; Somme pondre des 10 oscillateurs
			macr		x0,y0,a
			ptru		name\_pg
			sta		name

; Tester si une touche a t appuye
			move		#-1,b
			jcnf		name\_ck,name\_p3
			ptr		name\_pt,4,name\_genes,19

			lda		name\_in
			lsr		#16,a
			move		#name\_touches,r1
			move		#-1,m1
			do			#18,name\_p2
			move		y:(r1)+,x0
			cmp		x0,a
			teq		a,b	r1,r2
name\_p2
			tst		b					; si b<0, caractre non reconnu
			bmi		name\_p3

			move		r2,a				; r2= adresse dans touches +1
			sub		#name\_touches+1,a
			add		#name\_facteurs,a
			move		a,r1				; r1 pointe le facteur complexe
			move		l:(r1),x			; X= facteur
			move		x,l:$1000
			move		r4,x:$1001
			move		#1.0,y0			; Y= 1+0j = valeur initiale du gn
			move		#0,y1
			move		y,l:(r4)+		; mise  jour d'une entre de genes
			move		x,l:(r4)+		; R4 pointe la prochaine  mettre  jour
			ptru		name\_pt 
name\_p3
			u	a
			u	b
			u	x
			u	y
			u	r4

			endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


