;; Commande d'Instrument MIDI
;; Transmet les commandes fournies par MIDI_SEQ dans Y:midi_cmdlist
;; Les commandes sont de la forme:
;; Y:(R0)-->status [evt,on,busy,...] 
;;  		note 
;;        	Freq
;;		Velocity  


midicmd	macro	name,chan,nr

name\_exe
 if @def(name\_start_b)
	flagrst	name\_start
 endif
 if @def(name\_stop_b) 
	flagclr 	name\_stop
 endif
 if @def(name\_enable_b)
	bcc		<name\00
	flagclr	name\_enable
 endif 
name\00
	move		#midi_cmdlist+chan*40+(4*nr),r0
	move		#-1,m0
	nop

name\0
;	bclr		#21,y:(r0)
	bclr		#23,y:(r0)
	bcc		<name\4
name\1
	btst		#22,y:(r0)
	bcs		<name\2
 if @def(name\_stop_b)
	flagset	name\_stop
 endif
	bra		<name\3	;; name\_0 
name\2
 if @def(name\_enable_b)
	flagset	name\_enable
 endif
 if @def(name\_start_b)
	flagset	name\_start
 endif
  if @def(name\_stop_b)
	flagclr	name\_stop
 endif
name\3
 if @def(name\_note) 
	move		y:(r0+1),a
	sta		name\_note
 endif
 if @def(name\_freq) 	
	move		y:(r0+2),a
	sta1		name\_freq
 endif 
 if @def(name\_velo)
	move		y:(r0+3),a
	sta1		name\_velo
 endif 
name\4

	u	a
	u	r0
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use




