; MSK modulator. Generates Sine at Bauds or Sine at 1.5*bauds 
; wether input symbol is 0 or 1. Symbol rate is given by flag <name>

modmsk	macro	name,bauds

	coefd	name\_delta,2.*bauds/actual_fs
	coefd	name\_delta1,3.*bauds/actual_fs

	vard	name\_int,0
	vard	name\_phi,0
	cn	name\_phi,name\_s_in
 if	@def(name\_im)
	cnc	name\_s,name
 else
	cn	name\_s,name
 endif

	org	p:
	flagrst	name\_ck
	move		l:name\_int,a
	move		l:name\_phi,b
	move		l:name\_delta,x
	add		x,a
	move		a10,l:name\_int
	bec		<name\_1
	flagset	name\_ck
	move		#0.1,y0
	cmpm	y0,b
	clr		b	 iflt	
name\_1
	lda		name\_in
	tst		a
	blt		<name\_2
	move		l:name\_delta1,x
name\_2
	add		x,b
	move		b10,l:name\_phi
 if @def(name\_im)
	f_sincos	name\_s,15
 else
	f_sin		name\_s,15
 endif

	u	a
	u	b
	u	x
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use

