;; MVAV moving average

mvav	macro	name,time,unit,gain
	vard	name\_s,0
	if	"unit"=='smp'
name\_n	set	time
	else
name\_n	set	@cvi(time*actual_fs)
	endif
name\_k	set	gain/@cvf(name\_n)
name\_rg	set	@cvi(@cel(@log(name\_k)/@log(2.)))
name\_fr	set	name\_k/@pow(2.0,name\_rg)

 if	@def(name\_im)
	vard	name\_sim,0
	bufm	name\_buf,l,name\_n
 else 
	bufm	name\_buf,x,name\_n
 endif 
	section	inits
	move	#name\_buf,r0
	move	#-1,m0
	move	#name\_n,n0
	clr	a
	rep	n0
 if	@def(name\_im)
	move	a,l:(r0)+
	sta	name\_sim
 else
	move	a,x:(r0)+
 endif 
	sta	name\_s

	endsec 

	org	p:
	ptr	name\_p,0,name\_buf,name\_n-1

 if	@def(name\_im)
	lda	name\_in_im
	move	y:(r0),b
	move	a,y:(r0)
	asr	#24,a,a
	asr	#24,b,b
	sub	b,a	l:name\_sim,x
	add	x,a
	move	a,l:name\_sim
	asl	#24+name\_rg-1,a,a
	move	a,x0
	move	#>name\_fr,x1
	mpy	x0,x1,a
	asl	a
	rnd	a
	sta	name\_im

	lda	name\_in_re
 else
	lda	name\_in
 endif
	move	x:(r0),b
	move	a,x:(r0)+
	ptru	name\_p

	asr	#24,a,a
	asr	#24,b,b
	sub	b,a	l:name\_s,x
	add	x,a
	move	a,l:name\_s
	asl	#24+name\_rg-1,a,a
	move	a,x0
	move	#>name\_fr,x1
	mpy	x0,x1,a
	asl	a
	rnd	a
 if	@def(name\_im)
	sta	name\_re
 else
	sta	name
 endif


	u	a
	u	b
	u	x
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use



 