;; Parallel In Serial Out shift register
;; Produces one bit each sample
;; Sets wck=1 at each new word 1st bit

piso	macro	name,length,first

	var	name\_sr,0

	org	p:
	lda	name\_sr
	flagrst 	name\_wck
 if		"first"=='MSB_First'
	lsl	a
	bne	name\_0
	lda	name\_in
  if length==8
	or	#$008000,a
	and	#$FF8000,a
  else
   if length==12
	or	#$000800,a
	and	#$FFF800,a
   else
	or	#$000080,a
	and	#$FFFF80,a
   endif
  endif
	flagset name\_wck
	lsl	a
 else				; LSB first
	lsr	a
	bne	name\_0
	lda	name\_in
  if length==8
	or	#$000100,a
	and	#$0001FF,a
  else
   if length==12
	or	#$001000,a
	and	#$001FFF,a
   else			; Lng 16
	or	#$010000,a
	and	#$01FFFF,a
   endif
  endif
	flagset name\_wck
	lsr	a
 endif
name\_0
	sta1	name\_sr
	bcs	name\_1
	flagclr	name
	bra	name\_end
name\_1
	flagset	name
name\_end

	u	a
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


