;; Write signal into a cyclic buffer
;; Read it at different speed


transpose	macro	name,size,ratio

	bufm	name\_buf,y,size
; 1+Cos(alpha) -- Hann window
	section	far	global
name\_a	 set	0.
name\_da set	2.*pi/@cvf(size)
	org	y:
	buffer	m,size
name\_pond
	dup	size
	dc	-0.5*(@cos(name\_a)-1.)
name\_a set	name\_a+name\_da
	endm
	endbuf
	endsec
name\_buf_segmts set size-1
name\_pond_segmts set size-1

	var	name\_rd1,0
	var	name\_rd2,0

	cn	name\_saw1,name\_rd1_in
	cn	name\_saw2,name\_rd2_in

	org	p:
name\_exe
	ptr	name\_wp,1,name\_buf,(size-1)

	lda	name\_in
	move	a,y:(r1)+
	ptru	name\_wp

	g_saw	name\_saw1,(2.*ratio/@cvf(size)),rel
	move	#-1.,x0
	add	x0,a
	sta1	name\_saw2
	tblrd	name\_rd1,name\_buf,s
	move	#size-1,m2
	move	r0,n1
	lua	(r1)-n1,r2
	tblrd	name\_rd2,name\_buf,s
	move	#name\_pond,n2
	move	y:(r2+n2),y0

	lda	name\_rd2
	ldx0	name\_rd1
	mac	x0,y0,a		a,x1
	macr	-x1,y0,a
	sta	name

	u	a
	u	x
	u	y
	u	r1
	u	n1
	u	r2

	endm


	






;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


