;; Connect data  source --- destination
;; Syntax:	cn	source,destination
;; If neither source nor destination are defined, create a 24 bit variable named source,
;; define destination as identical to source
;; Normally 24 bit connection. If one end already defined, connects also double or complex
;; JMO REV oct 2004
;; cn.bmp

cn	macro	source,destin
 if	@def(source)
  if	!@def(destin)
   if	@msp(source)==0
destin	equ	source	;; constant equate
	else
	if	@msp(source)==1				;; @msp(sce)!=0
	section	vars	global
    	endif
    	if	@msp(source)==2
	section	data	global
    	endif
    	if	@msp(source)==3
	section	long	global
    	endif

destin	equ	source

    if	(@def(source\_re))&&(@def(source\_im))
destin\_re equ	source\_re
destin\_im equ	source\_im
    endif
    if	@msp(source)!=0
	endsec
    endif
   endif	;; @msp()!=0
  else
	fail	'SHORT CIRCUIT : ',"source",' and ',"destin",' are both already defined !'
  endif				;; def destin
 else					;; !def source
  if	@def(destin)
  	cn	destin,source
  else
	var	source,0
	msg	"source",' variable created'
	section	vars global
destin	  equ	 source
	endsec
  endif
 endif
	endm	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 17/08/2007

