;; Connect data  source --- destination
;; Syntax:	cn	source,destination
;; If neither source nor destination are defined, create a 24 bit variable named source,
;; define destination as identical to source
;; Normally 24 bit connection. If one end already defined, connects also double or complex
;; JMO REV oct 2004
;; cn.bmp

cn	macro	source,destin
 if	@def(source)
  if	!@def(destin)
   if	@msp(source)==0
destin	equ	source	;; constant equate
destin\_sect equ 0
   else				;; @msp(sce)!=0
    if	source\_sect==1
	section	vars	global
    endif
    if	source\_sect==2
	section	data	global
    endif
    if	source\_sect==3
	section	long	global
    endif

destin	equ	source
destin\_sect equ source\_sect

    if	(@def(source\_re))&&(@def(source\_im))
destin\_re equ	source\_re
destin\_im equ	source\_im
destin\_re_sect equ source\_re_sect
destin\_im_sect equ source\_im_sect
    endif
    if	source\_sect!=0
	endsec
    endif
   endif	;; @msp()!=0
  else
	fail	'SHORT CIRCUIT : ',"source",' and ',"destin",' are both already defined !'
  endif				;; def destin
 else					;; !def source
  if	@def(destin)
  	cn	destin,source
  else
	var	source,0
	msg	"source",' variable created'
	section	vars global
destin	  equ	 source
destin\_sect  equ	 source\_sect
	endsec
  endif
 endif
	endm	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 09/11/2005

