;; Connect double data   source---destination
;; Syntax:	cnd	source,destination
;; If neither source nor destination are defined, create a 48 bit variable named source,
;; define source and destination as identical
;;
;; JMO REV 27-10-04
;; cnd.bmp

cnd	macro	source,destin
 if	@def(source)
  if	!@def(destin)

   if	source\_sect==3
	section	long	global
	else
	fail	"source",' is not defined as a double: Use cnd with ',"source",' at first !'
   endif

destin		equ	source
destin\_sect 	equ	3

    if	(@def(source\_re))&&(@def(source\_im))
destin\_re equ	source\_re
destin\_im equ	source\_im
destin\_re_sect equ	source\_re_sect
destin\_im_sect equ	source\_im_sect
    endif
	endsec
  else
	fail	'SHORT CIRCUIT : ',"source",' and ',"destin",' are both already defined !'
  endif			;; def destin
 else			;; !def source
  if	@def(destin)
  	cnd	destin,source
  else
	vard	source,0
	msg	"source",' double variable created'
	section	long	global
destin	equ	source
destin\_sect equ	3
	endsec
  endif
 endif
	endm	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 21/10/2005

