;; Connect matrix
;; Syntax:	cnm	source,dest[,lin,col]
;; If neither source nor destination are defined, create a lin*col matrix variable named source,
;; define source and dest as identical location and dimensions
;;
;; JMO 27-10-04
;; cnm.bmp

cnm	macro	source,destin,lin,col
 if	@def(source)
  if	!@def(destin)
destin\_sect	set		3
 if @msp(source)==3
	section longfar global
 else
	section	far	global
 endif
destin	equ	source
destin\_lin	equ	source\_lin
destin\_col	equ	source\_col
	endsec
  else
	fail	'SHORT CIRCUIT : ',"source",' and ',"destin",' are both already defined !'
  endif			;; def destin
 else			;; !def source
  if	@def(destin)
  	cnm	destin,source
  else
	mat	source,x,lin,col
	msg	"source",' ',lin,'x',col,' matrix created in X:'
	cnm	source,destin
  endif		;; !def destin
 endif			;; def source
	endm	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 19/09/2012

