;; define a complex constant
;; Syntaxes:
;; constc name,ro,alpha,p   	= Polar form: alpha expressed in half turns (alpha = [-1..+1[)
;; constc name,re,im,c		= Cartesian form 
;;
;; JMO Rev 21-10-05

constc	macro	name,u,v,w
  if	!@def(name)
name\_sect	equ		0
	if	"w"=='p'
name		equ		@lng(@frc(u*@cos(v*pi)),@frc(u*@sin(v*pi)))
name\_re 	equ		u*@cos(v*pi)
name\_im 	equ		u*@sin(v*pi)
	else
name		equ		@lng(@frc(u),@frc(v))
name\_re 	equ		u
name\_im 	equ		v
	endif	
  else
	warn	'Constant ',"name",' already defined !'
  endif		; def(nam)
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 09/11/2005

