;; End of an interrupt routine
;; Includes context save and restore routines

endint	macro	name

critic	set	0		;; critic area ends here


; Memory for holding the context
	section	longfar	global
	global	sav_\name
	org	l:
sav_\name
	ds	savwrds+1
	endsec




	org	p:
rest_\name
	move	#sav_\name+1,r0
	move	#-1,m0

	if	used_a
	move	x:(r0)+,a2
	move	l:(r0)+,a10
	endif
	
	if	used_b
	move	x:(r0)+,b2
	move	l:(r0)+,b10
	endif
	
	if	used_x
	move	l:(r0)+,x
	endif
	
	if	used_y
	move	l:(r0)+,y
	endif


	if	used_n0
	move	x:(r0)+,n0
	endif
		
	if	used_r1
	move	x:(r0)+,r1
	endif
	if	used_m1
	move	x:(r0)+,m1
	endif
	if	used_n1
	move	x:(r0)+,n1
	endif

	if	used_r2
	move	x:(r0)+,r2
	endif
	if	used_m2
	move	x:(r0)+,m2
	endif
	if	used_n2
	move	x:(r0)+,n2
	endif

	if	used_r3
	move	x:(r0)+,r3
	endif
	if	used_m3
	move	x:(r0)+,m3
	endif
	if	used_n3
	move	x:(r0)+,n3
	endif

	if	used_r4
	move	x:(r0)+,r4
	endif
	if	used_m4
	move	x:(r0)+,m4
	endif
	if	used_n4
	move	x:(r0)+,n4
	endif

	if	used_r5
	move	x:(r0)+,r5
	endif
	if	used_m5
	move	x:(r0)+,m5
	endif
	if	used_n5
	move	x:(r0)+,n5
	endif

	if	used_r6
	move	x:(r0)+,r6
	endif
	if	used_m6
	move	x:(r0)+,m6
	endif
	if	used_n6
	move	x:(r0)+,n6
	endif

	if	used_r7
	move	x:(r0)+,r7
	endif
	if	used_m7
	move	x:(r0)+,m7
	endif
	if	used_n7
	move	x:(r0)+,n7
	endif

	move	x:sav_\name,r0
	move	y:sav_\name,m0

	rti
	


	
;; Routine for saving registers called from macro SAVE
		
save_\name
	move	r0,x:sav_\name
	move	m0,y:sav_\name
	
	move	#sav_\name+1,r0
	move	#-1,m0

	if	used_a
	move	a2,x:(r0)+
	move	a10,l:(r0)+
	endif
	
	if	used_b
	move	b2,x:(r0)+
	move	b10,l:(r0)+
	endif
	
	if	used_x
	move	x,l:(r0)+
	endif
	
	if	used_y
	move	y,l:(r0)+
	endif


	if	used_n0
	move	n0,x:(r0)+
	endif
		
	if	used_r1
	move	r1,x:(r0)+
	endif
	if	used_m1
	move	m1,x:(r0)+
	endif
	if	used_n1
	move	n1,x:(r0)+
	endif

	if	used_r2
	move	r2,x:(r0)+
	endif
	if	used_m2
	move	m2,x:(r0)+
	endif
	if	used_n2
	move	n2,x:(r0)+
	endif

	if	used_r3
	move	r3,x:(r0)+
	endif
	if	used_m3
	move	m3,x:(r0)+
	endif
	if	used_n3
	move	n3,x:(r0)+
	endif

	if	used_r4
	move	r4,x:(r0)+
	endif
	if	used_m4
	move	m4,x:(r0)+
	endif
	if	used_n4
	move	n4,x:(r0)+
	endif

	if	used_r5
	move	r5,x:(r0)+
	endif
	if	used_m5
	move	m5,x:(r0)+
	endif
	if	used_n5
	move	n5,x:(r0)+
	endif

	if	used_r6
	move	r6,x:(r0)+
	endif
	if	used_m6
	move	m6,x:(r0)+
	endif
	if	used_n6
	move	n6,x:(r0)+
	endif

	if	used_r7
	move	r7,x:(r0)+
	endif
	if	used_m7
	move	m7,x:(r0)+
	endif
	if	used_n7
	move	n7,x:(r0)+
	endif

	rts

	endsec
	endm

	
		





;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 19/09/2012

