;; FIBULA application epilogue
	nolist

; End of all sections: gives the sections sizes

	section flags	global
	org	y:
endflags
	endsec

	section	vars	global
	org	x:
end_var
	endsec

	section	data	global
	org	y:
end_data
	endsec


	section long	global
	org	l:
end_dbl
	endsec	

	section	irq
	org	p:
endirq
	endsec

	if	@def(curman)	; number of manual entries
nbman	set	curman
	endif


	section	inits
	global	endini
	org	p:

	movep	#val_pcrc,x:PCRC
	movep	#val_prrc,x:PRRC
	movep	#val_pdrc,x:PDRC

	movep	#val_pcre,x:PCRE
	movep	#val_prre,x:PRRE
	movep	#val_pdre,x:PDRE


	movep	#val_pcrh,x:PCRH
	movep	#val_prrh,x:PRRH
	movep	#val_pdrh,x:PDRH
 if core==0
	movep	#val_pcrg,y:PCRG
	movep	#val_prrg,y:PRRG
	movep	#val_pdrg,y:PDRG

	movep	#val_pcrg,y:PCRG1
	movep	#val_prrg,y:PRRG1
	movep	#val_pdrg,y:PDRG1

	movep	#val_pcra,y:PCRA
	movep	#val_prra,y:PRRA
	movep	#val_pdra,y:PDRA

	movep	#val_pcra,y:PCRA1
	movep	#val_prra,y:PRRA1
	movep	#val_pdra,y:PDRA1
 endif

	movep	#val_iprc,x:IPRC
	movep	#val_iprc1,x:IPRC1
	movep	#val_iprp,x:IPRP
	movep	#val_iprp1,x:IPRP1

	movec	#val_sr,sr 
	nop
	nop
	nop	
	rts
endini	
	endsec

	section	routines
	org	p:
endrtn
	endsec


;	section	exec
	org	p:
	jmp	$0	; If programmer forgot to loop, then go to Debugger
endexec
	endsec

	section debug	global
	org	p:
enddbg
	endsec


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 18/01/2010

