;; Reverse carry addressing read of complex buffer.
;; Calculate power for each point = (Re+Im) 
;; Make mean value by 1st order filtering Pn = ka*Pn-1 + kb*(Re+Im)

mpow	macro	name,sbuf,size

	if	!@def(name)
	section	longfar	global
	org	l:
; mean power outputs ordered in growing frequencies
name	ds	size/2	
	endsec
	endif
	
; 	section exec
	org	p:
mpow_\name
	move	#sbuf,r1
	move	#size/2,n1
	move	#0,m1
	move	#name,r2	
	move	#-1,m2
	move	l:(r1)+n1,x
	do	#size/2,_mpow1
	mpy	x0,x0,a		x1,x0
	mac	x0,x0,a		l:(r2),b	;l:(r0)+n0,x
	sub	b,a		l:(r1)+n1,x
	asr	#5,a,a
	add	b,a
	move	a,l:(r2)+
_mpow1
	move	m2,m1
;	endsec

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 19/09/2012

