savrestisr	macro

critic	gset	0

	org	p:
; Restore registers modified during interrupt

savrest_sv set	1
	move	#savrest_sav+1,r0
	move	#-1,m0

	if	used_a
	move	x:(r0)+,a2
	move	l:(r0)+,a10
savrest_sv set	savrest_sv+2
	endif
	
	if	used_b
	move	x:(r0)+,b2
	move	l:(r0)+,b10
savrest_sv set	savrest_sv+2
	endif
	
	if	used_x
	move	l:(r0)+,x
savrest_sv set	savrest_sv+1
	endif
	
	if	used_y
	move	l:(r0)+,y
savrest_sv set	savrest_sv+1
	endif


	if	used_n0
	move	x:(r0)+,n0
savrest_sv set	savrest_sv+1
	endif
		
	if	used_r1+used_m1
	move	x:(r0),r1
	move	y:(r0)+,m1
savrest_sv set	savrest_sv+1
	endif
	if	used_n1
	move	x:(r0)+,n1
savrest_sv set	savrest_sv+1
	endif

	if	used_r2+used_m2
	move	x:(r0),r2
	move	y:(r0)+,m2
savrest_sv set	savrest_sv+1
	endif
	if	used_n2
	move	x:(r0)+,n2
savrest_sv set	savrest_sv+1
	endif

	if	used_r3+used_m3
	move	x:(r0),r3
	move	y:(r0)+,m3
savrest_sv set	savrest_sv+1
	endif
	if	used_n3
	move	x:(r0)+,n3
savrest_sv set	savrest_sv+1
	endif

	if	used_r4+used_m4
	move	x:(r0),r4
	move	y:(r0)+,m4
savrest_sv set	savrest_sv+1
	endif
	if	used_n4
	move	x:(r0)+,n4
savrest_sv set	savrest_sv+1
	endif

	if	used_r5+used_m5
	move	x:(r0),r5
	move	y:(r0)+,m5
savrest_sv set	savrest_sv+1
	endif
	if	used_n5
	move	x:(r0)+,n5
savrest_sv set	savrest_sv+1
	endif

	if	used_r6+used_m6
	move	x:(r0),r6
	move	y:(r0)+,m6
savrest_sv set	savrest_sv+1
	endif
	if	used_n6
	move	x:(r0)+,n6
savrest_sv set	savrest_sv+1
	endif

	if	used_r7+used_m7
	move	x:(r0),r7
	move	y:(r0)+,m7
savrest_sv set	savrest_sv+1
	endif
	if	used_n7
	move	x:(r0)+,n7
savrest_sv set	savrest_sv+1
	endif

	move	x:savrest_sav,r0
	move	y:savrest_sav,m0
 if @def(test_b) 
	flagclr	test
 endif 

	rti
	


	
; Routine for saving registers used during IRQ exe
		
savrest_save
 if @def(test_b) 
	flagset	test
 endif 

	move	r0,x:savrest_sav
	move	m0,y:savrest_sav
	
	move	#savrest_sav+1,r0
	move	#-1,m0

	if	used_a
	move	a2,x:(r0)+
	move	a10,l:(r0)+
	endif
	
	if	used_b
	move	b2,x:(r0)+
	move	b10,l:(r0)+
	endif
	
	if	used_x
	move	x,l:(r0)+
	endif
	
	if	used_y
	move	y,l:(r0)+
	endif


	if	used_n0
	move	n0,x:(r0)+
	endif
		
	if	used_r1+used_m1
	move	r1,x:(r0)
	move	m1,y:(r0)+
	endif
	if	used_n1
	move	n1,x:(r0)+
	endif

	if	used_r2+used_m2
	move	r2,x:(r0)
	move	m2,y:(r0)+
	endif
	if	used_n2
	move	n2,x:(r0)+
	endif

	if	used_r3+used_m3
	move	r3,x:(r0)
	move	m3,y:(r0)+
	endif
	if	used_n3
	move	n3,x:(r0)+
	endif

	if	used_r4+used_m4
	move	r4,x:(r0)
	move	m4,y:(r0)+
	endif
	if	used_n4
	move	n4,x:(r0)+
	endif

	if	used_r5+used_m5
	move	r5,x:(r0)
	move	m5,y:(r0)+
	endif
	if	used_n5
	move	n5,x:(r0)+
	endif

	if	used_r6+used_m6
	move	r6,x:(r0)
	move	m6,y:(r0)+
	endif
	if	used_n6
	move	n6,x:(r0)+
	endif

	if	used_r7+used_m7
	move	r7,x:(r0)
	move	m7,y:(r0)+
	endif
	if	used_n7
	move	n7,x:(r0)+
	endif

	rts

; Memory for saving the context
	section	longfar	global

	org	l:
savrest_sav
	ds	savrest_sv
	endsec



	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 19/09/2012

