;; Send Character to serial line
;; Syntax:	   sndc
;; Input: sndc_in = ascii code to send, left-justified
;; Input: sndc_ck = trigger transmission (Boolean, auto-reset) 
;; Input: sndc_error = send altcolor-ON + ascii + altcolor-OFF (Boolean) 



sndc	macro

	org		p:
 if @def(sndc_error_b)
	jnot		sndc_error,sndc0
	flagset	sndc_err
sndc0
 endif
	jnot		sndc_ck,sndc1
	lda		sndc_in
	and		#>$FF0000,a
 if @def(sndc_error_b) 
	move		#>$001000,b
	flagclr	sndc_err
	add		b,a	ifcs
 endif
	putfifo		sndc,256,0	; A1=12b (8char + 4 Attr) en b23..b12
sndc1
	sendch

	u	a
	u	b
	u	x
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 15/09/2011

