;; Codec CS4270 carte Fusilier
;; connect sur ESAI3 du processeur 2
;; MCK = HCKT_3  ;  SCLK = SCKT_3 ; LRCK = FST_3
;; SDIN = SDO2_3 (sdi3_3)
;; SDOUT = SDI2_3 (sdo3_3)

i_codec	macro	fs
;registres (Y:)
saicr_3	set	$ffff94
saisr_3	set	$ffff93
tccr_3	set	$ffff96
tcr_3		set	$ffff95
rccr_3	set	$ffff98
rcr_3		set	$ffff97
tx2_3		set	$ffff82
rx2_3		set	$ffff8A
tsr_3		set	$ffff86
pcre_1	set	$ffff9f
prre_1	set	$ffff9e
pdre_1	set	$ffff9d

	var	esai3_error

	section	inits
	movep	#$080000,y:tcr_3		; reset
	movep	#$080000,y:rcr_3
	movep	#$000040,y:saicr_3	; sync

 if fs==4
	movep	#$EEC30F,y:tccr_3
actual_fs	set	8000.
 endif

 if fs==8
	movep	#$EEC30F,y:tccr_3
actual_fs	set	8000.
 endif
 if fs==12
	movep	#$EDC30F,y:tccr_3
actual_fs	set	12000.
 endif
 if fs==16
	movep	#$EEC307,y:tccr_3
actual_fs	set	16000.
 endif
 if fs==24
	movep	#$EDC307,y:tccr_3
actual_fs	set	24000.
 endif
 if fs==32
	movep	#$EEC303,y:tccr_3
actual_fs	set	32000.
 endif
 if fs==48
	movep	#$ECC307,y:tccr_3
actual_fs	set	48000.
 endif
 if fs==96
	movep	#$ECC303,y:tccr_3
actual_fs	set	96000.
 endif
 if fs==192
	movep	#$EC4303,y:tccr_3
actual_fs	set	192000.
 endif

	movep	#$0C0200,y:rccr_3	; ckp, fsp, tdc
	movep	#$607D04,y:tcr_3
	movep	#$607D04,y:rcr_3

	movep	#0,y:tx2_3


;	movep	#$000338,Y:pcre_1 
;	movep	#$000338,y:prre_1	; pins ESAI = 1 et 1 
val_pcre1	set	val_pcre1|$000338
val_prre1	set	val_prre1|$000338

;	movep	#$000C00,x:$FFFFFE	; IPRP
;	andi	#$FC,mr
val_iprp1 	set	val_iprp1|$000C00
val_sr1	set	val_sr1&$fffcff

	endsec

	section	vectors global
	org	p:$70				; rx data
	jsr	irqesai3rx

	org	p:$72				; rx even data
	jsr	irqesai3rxv

	org	p:$74				; rx data with except
	jsr	irqesai3rxe

	org	p:$76				; rx last slot
	jsr	irqesai3rxl

	org	p:$78				; tx data
	jsr	irqesai3tx

	org	p:$7A				; tx even data
	jsr	irqesai3txv

	org	p:$7C				; tx data with except
	jsr	irqesai3txe

	org	p:$7E				; Tx last slot
	jsr	irqesai3txl

	endsec

	section	irq
	global  irqesai3rxe,irqesai3rx,irqesai3rxv,irqesai3rxl,irqesai3txe,irqesai3tx,irqesai3txv,irqesai3txl,savrest_save
irqesai3rxe
	movep	y:saisr_3,x:esai3_error
	movep	y:rx2_3,x:esai3_error
	rti

irqesai3rx
 if @def(in_r)
	movep	y:rx2_3,x:in_r
 endif
	rti

irqesai3rxv
 if @def(in_l)
	movep	y:rx2_3,x:in_l
 endif
	rti

irqesai3rxl
;	flagset codecdone
	rti

irqesai3txe
	movep	y:saisr_3,x:esai3_error
	movep	#0,y:tx2_3
	rti

irqesai3tx
	movep	x:out_r,y:tx2_3
	rti

irqesai3txl
;	flagset	codecdone
	rti


irqesai3txv
	movep	x:out_l,y:tx2_3
	flagset codecdone
critic	gset	1
	jsr	savrest_save

	endsec


	org	p:
;wait_codec
;	jcnf	codecdone,wait_codec 

	endm