;; FIBULA application epilogue
; End of all sections: gives the sections sizes



	section flags		global
	org	y:
endflags
	endsec

	section	vars	global
	org	x:
end_var
	endsec

	section	data	global
	org	y:
end_data
	endsec


	section long	global
	org	l:
end_dbl
	endsec	

	section	irq
	org	p:
endirq
	endsec

	if	@def(curman)	; number of manual entries
nbman	set	curman
	endif


	section	inits
	global	endini
	org	p:
 if core==0
	movep	#val_pcrc0,x:PCRC
	movep	#val_prrc0,x:PRRC
	movep	#val_pdrc0,x:PDRC		

	movep	#val_pcre0,y:PCRE
	movep	#val_prre0,y:PRRE
	movep	#val_pdre0,y:PDRE
	movep	#val_pcrh,x:PCRH
	movep	#val_prrh,x:PRRH
	movep	#val_pdrh,x:PDRH

	movep	#val_pcrg,y:PCRG
	movep	#val_prrg,y:PRRG
	movep	#val_pdrg,y:PDRG

	movep	#val_pcrg1,y:PCRG_1
	movep	#val_prrg1,y:PRRG_1
	movep	#val_pdrg1,y:PDRG_1

	movep	#val_iprc0,x:IPRC
	movep	#val_iprc01,x:IPRC1
	movep	#val_iprp0,x:IPRP
	movep	#val_iprp01,x:IPRP1

	movec	#val_sr0,sr
 	endif
 
 if core==1
	movep	#val_pcrc1,x:PCRC
	movep	#val_prrc1,x:PRRC
	movep	#val_pdrc1,x:PDRC

	movep	#val_pcre1,y:PCRE
	movep	#val_prre1,y:PRRE
	movep	#val_pdre1,y:PDRE


	movep	#val_pcrg,y:PCRG	; double init ncessaire (shared port) 
	movep	#val_prrg,y:PRRG
	movep	#val_pdrg,y:PDRG

	movep	#val_pcrg1,y:PCRG_1
	movep	#val_prrg1,y:PRRG_1
	movep	#val_pdrg1,y:PDRG_1

	movep	#val_pcrh,x:PCRH
	movep	#val_prrh,x:PRRH
	movep	#val_pdrh,x:PDRH


	movep	#val_iprc1,x:IPRC
	movep	#val_iprc11,x:IPRC1
	movep	#val_iprp1,x:IPRP
	movep	#val_iprp11,x:IPRP1

	movec	#val_sr1,sr
 	endif

	nop
	nop
	nop	
	rts
endini	
	endsec

	section	routines
	org	p:
endrtn
	endsec


;	section	exec
	org	p:
	jmp	$0	; If programmer forgot to loop, then go to Debugger
endexec
	endsec

	section debug	global
	org	p:
enddbg
	endsec







;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 30/05/2012

