;; codec CS5340
;;				HCKT	PE5_1
;;				FST	PE4_1
;;		ESAI1_0	HCKR	PE2_1
;; SCLK	ESAI1_2	SCKR	PE0_1
;; LRCK	ESAI1_4	FSR	PE1_1
;; SDOUT	PIO10		SDI0_3 PE6_1  RX0

i_iq_adc	macro	fs

	var	esai_error
;	var	debug_cs
; if !@def(qsd_im)
;	var		qsd_im,0
; endif
; if !@def(qsd_re)
;	var		qsd_re,0
; endif

;;epsc	set	$ffffe3

pdrh_1	set	$ffff98

	section	inits
val_pcre1	set	val_pcre1|$0000F7		;47
val_prre1	set	val_prre1|$0000F7  	;47


	movep	#$080000,y:rcr_1		; reset RX

 	movep	#$000000,y:saicr_1		; async

;;	movep	#val_prre1,y:prre
;;	movep	#val_pcre1,y:pcre

	

 if fs==48
	movep	#$ECc307,y:rccr_1
	movep	#$617D01,y:rcr_1		;617D01
 endif

 if fs==96
	movep	#$EC4307,y:rccr_1
	movep	#$617D01,y:rcr_1
 endif

 if fs==192	
	movep	#$EC4303,y:rccr_1
	movep	#$617D01,y:rcr_1
 endif

;;	movep	#$0,y:RSMB			; transmit slot mask
;;	movep	#$3,y:RSMA			; enable slots 0 & 1 only

val_iprp1 	set	val_iprp1|$000C00
val_sr1	set	val_sr1&$fffcff

core1_fs	set	actual_fs

	nolist
	nolist
	msg	'>>> CODEC Fs=',@cvi(fs*1000),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(0.001*fdsp/fs)
	list
	list

	endsec


	section	vectors global
	org	p:$70				; rx data
	jsr	irqesairx

	org	p:$72				; rx even data
	jsr	irqesairxv


	endsec

	section	irq
	global  irqesairx,irqesairxv

irqesairx
 if @msp(sdr_rx_hf_im)==2
	movep	y:rx0_1,y:sdr_rx_hf_im
 else
	movep y:rx0_1,x:sdr_rx_hf_im
 endif
	rti

irqesairxv
 if @msp(sdr_rx_hf_re)==2
	movep	y:rx0_1,y:sdr_rx_hf_re
 else
	movep y:rx0_1,x:sdr_rx_hf_re
 endif
 	flagset codecdone
critic	gset	1
	jsr	savrest_save

;	rti


	endsec

	org	p:

;wait_codec
;	jcnf	codecdone,wait_codec


	endm




