;; Module I2C pour communication avec module SDR via le FPGA
;; 

  if !@mac(init_bus)
  include 'dsp_bus.asm'
  init_bus
  endif

i2c_fpga	macro

fpga_base	set	$040000
status_pb set fpga_base+$10
fifo_fpga set fpga_base+$012

  section data global
  org y:
gotoxy_trame  dcb   $21,$80  
clear_trame   dcb   $21,$01
  endsec

	org	p:

;;	section inits


;;	endsec

	section	routines

	global	pcf8574_w
pcf8574_w
  move  y:(r0),a
  and   #$0F,a
  add   #1,a
  move a1,n0  
  move		#-1,m0
  do  n0,pcf8574_w1
  move y:(r0)+,a1
  move a1,x:fifo_fpga
pcf8574_w1 
  nop
	rts
  
  global  si_write
si_write
  move  #$03,a1
  move  a1,x:fifo_fpga
  move  r0,a1
  asr   #16,a,a
  move  a1,x:fifo_fpga
  move  r0,a1
  asr   #8,a,a
  move  a1,x:fifo_fpga
  move  r0,x:fifo_fpga
  move	#30000,n0
	rep	n0
	nop
  rts
  


	endsec
	endm
