;; Provoke IRQ to other core and Send message 
;; icc_snd_irq	name,message

icc_snd_irq	macro	name,message
	section	inits
	movep		#5,y:iccr3
	bset	#1,y:icar3 	;// Acknowledge last irq  
	endsec

	bset	#1,y:icar3 	;// Acknowledge last irq 
	movep	#5,y:iccr3
 if	@def(name\_in)
  if	@msp(name\_in)==2	
	movep	y:name\_in,y:icdr3
  else
	movep	x:name\_in,y:icdr3
  endif 
 else
	movep	#message,y:icdr3
 endif
_i1
	endm

 

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 11/09/2013

