;; module sdr_rx_27MHz
;; SDA PC7_1 SCL PC8_1
;; inversion LF et 27 MHz selecteur

	include 'rfdo.asm'
	if !@mac(i2c_fpga)
	include 'i2c_fpga.asm'
  i2c_fpga
	endif	
  if !@mac(fpga_aff)
	include 'fpga_aff.asm'
  endif
	
sdr_rx_hf	macro	bande,fosc

	var	name\ctrl_port
	section strings global
	opt	nops
	org	y:	
aff_str1	dc	'Bande='++"bande"
aff_str1_lng	set	*-aff_str1
;	str   aff_str1,"bande"
aff_str2	dc	'Frx='++"fosc"++'Hz'
aff_str2_lng	set	*-aff_str2
;	str	aff_str2,"fosc"
;	str	aff_str2,' Hz'
	endsec


  section data global
  org y:
sdr_rx_ctrl  dcb   $02,$40,$E0
  endsec	

	if 4*fosc<10e6	
div_clk	set 	$00
	rfdco 64*fosc
	else
div_clk	set	$08
	rfdco 4*fosc
	endif	
      if @mac(i2c_sdr) 
	i2c_sdr	
	endif


	org p:
	section  inits		
wait_pb:
  rep   #100
  nop
  move  x:status_pb,a1
  brclr #7,a1,wait_pb
  
  move #sdr_rx_ctrl,r0
	if ("bande"=='all')
  move  #$e0,a1
;;	str	aff_rx,'All'
	endif
	if ("bande"=='lf')
	move  #$d3,a1
  ;;	str	aff_rx,'LF'
	endif
	if ("bande"=='mf')
	move  #$b2,a1
  ;;	str	aff_rx,'MF'
	endif
	if ("bande"=='27_MHz')
	move  #$71,a1
;;	str	aff_rx,'27 MHz'
	endif
	or	#div_clk,a
  move  a1,y:(r0+2)
;;	STA1	name\ctrl_port
	jsr	pcf8574_w
  
  move	#30000,r0
	rep	r0
	nop
	

;;si570
	move	#>$AA8910,r0
	jsr	si_write
	move	#30000,n0
	rep	n0
	nop
	move	#>si_r7,r0		;;#>$AA0718,a1
	jsr	si_write
	move	#>si_r8,r0		;;#>$AA08C2,a1
	jsr	si_write
	move	#>si_r9,r0		;;#>$AA09BC,a1
	jsr	si_write
	move	#>si_r10,r0		;;#>$AA0A01,a1
	jsr	si_write
	move	#>si_r11,r0		;;#>$AA0B1E,a1
	jsr	si_write
	move	#>si_r12,r0		;;#>$AA0CB8,a1
	jsr	si_write
	move	#>$AA8900,r0	;; Unfreeze DCO
	jsr	si_write	
	move	#30000,n0		;; Newfreq
	rep	n0
	nop
	move	#>$AA8740,r0
	jsr	si_write
wait_si_cnf:  
  nop
  move	#100,n0
	rep	n0
	nop
  move  x:status_pb,a1
  brclr  #9,a1,wait_si_cnf
	
	fpga_aff	aff_str1,aff_str2
	endsec
	u	a
	u	r0
	u	n0
	endm
	

