sdram	macro
sdram_base	set	$40000

	section	inits

	movep	#0,y:PDRA
	movep	#0,y:PDRA_1		
	movep	#$FFFFFF,y:PCRA
	movep	#$FFFFFF,y:PRRA
	movep	#$000007,y:PCRA_1
	movep	#$000007,y:PRRA_1

	move		#$3861,a1			;; #$5861,a1
	move		a1,x:EMC_BRL1
	move		#0,a1  ; #$000080,a1
	move		a1,x:EMC_BRH1
	move		#$6900,a1
	move		a1,x:EMC_ORL1
	move		#0,a1	;#$2FF,a1
	move		a1,x:EMC_ORH1
	move		#0,a1
	move		a1,x:$FFFE42
	move		#$2000,a1
	move		a1,x:$FFFE43
	move		#$2522,a1
	move		a1,x:EMC_LSDMRL
	move		#$4002,a1
	move		a1,x:EMC_LSDMRH
	move		#0,a1
	move		a1,x:$FFFE52
	move		#$6400,a1
	move		a1,x:$FFFE53
	move		#$2,a1
	move		a1,x:EMC_LCRRL
	move		#$0,a1
	move		a1,x:EMC_LCRRH

	move		#20000,r0
	bsr		delay10ns

	move		#$2522,r4
	move		r4,x:EMC_LSDMRL
	move		#$6C02,r4
	move		r4,x:EMC_LSDMRH
	move		#$123456,r4
	move		r4,x:>$200000

	move		#2,r0
	bsr		delay10ns

	do		#8,looprefresh
	move		#$2522,r4
	move		r4,x:EMC_LSDMRL
	move		#$4C02,r4
	move		r4,x:EMC_LSDMRH
	move		#$123456,r4
	move		r4,x:>$200000

	move		#6,r0
	bsr		delay10ns
looprefresh

	move		#$2522,r4
	move		r4,x:EMC_LSDMRL
	move		#$5C02,r4
	move		r4,x:EMC_LSDMRH
	move		#$123456,r4
	move		r4,x:>$200000

	move		#2,r0
	bsr		delay10ns

	move		#$2522,r4
	move		r4,x:EMC_LSDMRL
	move		#$4002,r4
	move		r4,x:EMC_LSDMRH

	bclr		#23,y:CHIP_CFG_EMBC
	bset		#22,y:CHIP_CFG_EMBC

	endsec


	section 	routines
	global	delay10ns
	org		p:
delay10ns
	do		r0,delay10nsloop
	nop
	nop
delay10nsloop
	rts

	endsec

	endm






















	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 02/10/2013

