;; Argument of a complex input  y = arctan2(Im(x),Re(x)) / pi
;; Syntax:	angle	name
;; inputs:	name_in (complex) OR name_in_re, name_in_im (real) 
;; output: 	name (real)       coding = [-1..+1[ for [-pi..+pi[
;; 
;; JMO Rev 31/10/05
;; angle.bmp

angle	macro	name

	cn	name\_in_re,name\_inx
	cn	name\_in_im,name\_iny

	if	!@def(tbl_atan2)
atan2_pts	set	11
atan2_seg	set	atan2_pts-1
atan2_incr	set	2.0/@cvf(atan2_pts)
atan2_px	set	-1.0
atan2_py	set	-1.0

	section	data	global
	org	y:
tbl_atan2
	dupf	atan2_py,0,(atan2_pts-1)
atan2_psin	set	-1.0+@cvf(atan2_py)*2.0/atan2_seg
	dupf	atan2_px,0,(atan2_pts-1)
atan2_pcos	set	-1.0+@cvf(atan2_px)*2.0/atan2_seg
	dc	@at2(atan2_psin,atan2_pcos)/pi
	endm
	endm
tbl_atan2_xsegmts equ	atan2_seg
tbl_atan2_ysegmts equ	atan2_seg

	endsec
	endif
  dbgdisa
	tblr2d	name,tbl_atan2,0,s,s
  dbgena
	dbgw	ANGLE
	dbg	name\_in_re
	dbg	name\_in_im
	dbg	name

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
