;; Analog comparator   if input >, =, < to ref then  Output = oTrue, else Output = oFalse
;; Syntax:	compare	name,{gt|ge|eq|ne|le|lt},oTrue,oFalse
;; Inputs name_in, name_ref       output: name (real)
;; Optional inputs: name_t, name_f = output level values for condition true or false, if variable 

compare	macro	name,cc,ot,of

	coef	name\_t,ot
	coef	name\_f,of


	lda	name\_in
	ldx0	name\_ref
	cmp	x0,a

	if	"cc"=='gt'
	bgt	<name\_1
	endif

	if	"cc"=='ge'
	bge	<name\_1
	endif

	if	"cc"=='eq'
	beq	<name\_1
	endif

	if	"cc"=='ne'
	bne	<name\_1
	endif

	if	"cc"=='le'
	ble	<name\_1
	endif

	if	"cc"=='lt'
	blt	<name\_1
	endif

	lda	name\_f
	sta	name

	bra	<name\_2
name\_1
	lda	name\_t
	sta	name
name\_2

	u	a
	u	x

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


