;; Sine function	y = Sin(pi*x)
;; Syntax:	f_sin	name,points
;; Points defines the 0..pi/2 table resolution (15 is enough in most cases)
;; Input: name_in	Output:	name

f_sin	macro	name,points

	if	!@def(sinq\points)
	section far global
	org	y:
name\_angle	set	0.0
sinq\points
; 0..pi/2 sine table here
	nolist
	dup	points-1
	dc	@sin(name\_angle)
name\_angle	set	name\_angle+pi/(2.*@cvf(points-1))
	endm
	dc	$7fffff
sinq\points\_segmts set	points-1
sinq\points\_size set points
	endsec
	list
	endif


	org	p:
	cc_rst
name\_exe

	org	p:
	lda	name\_in
	asl	a	a,b
	move	a1,a
	abs	a
	cc_ac	1
	regin
	dbgdisa
name\_t_accu	set	1
	tblrd	name\_t,sinq\points,u
	dbgena
	cc_rst
	tst	b
	neg	a	iflt
	sta	name
	cc_ac	1

	u	a
	u	b
	u	r0
	u	x
	varin

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


