;; Step function  y = value_left if x<threshold , y = value_right otherwise
;; Syntax:	f_step	name,thr,valueleft,valueright
;;
;; Input: name_in	Output: name
;; Optional input: name_thr


f_step	macro	name,t,vl,vr

	section	long	global
	org	l:
name\_vlr	dc	@lng(@frc(vr),@frc(vl))
	endsec
 if !@def(name\_t)
	coef	name\_t,t
 endif
	org	p:

	lda	name\_in
	ldx0	name\_t
	cmp	x0,a	l:name\_vlr,x
	tge	x1,a
	tlt	x0,a
	sta	name

	dbgw	f_step
	dbg	name\_in
	dbgi	name

	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


