;; Binary Pseudo-random generator y(k) = sgn[x(k)] with x(k)= (x(k-1) xor weight)<< + C  
;; Syntax: 	g_bpr	name,bits
;; Sequence length is (2^bits - 1) Delayed sequences are orthogonal
;; Output: name (value +1 or -1)  Optional output: name_sr


g_bpr	macro	name,bits

	if	bits==3 
name\_w	set	$700000
	endif
	if	bits==4 
name\_w	set	$380000
	endif
	if	bits==5
name\_w	set	$2C0000
	endif
	if	bits==6 
name\_w	set	$0E0000
	endif
	if	bits==7 
name\_w	set	$070000
	endif
	if	bits==8
name\_w	set	$878000
	endif
	if	bits==9
name\_w	set	$08C000
	endif
	if	bits==10
name\_w	set	$026000
	endif
	if	bits==11
name\_w	set	$00B000
	endif
	if	bits==12
name\_w	set	$107800
	endif
	if	bits==13
name\_w	set	$013C00
	endif
	if	bits==14
name\_w	set	$401E00
	endif
	if	bits==15
name\_w	set	$010300
	endif
	if	bits==16
name\_w	set	$100B80
	endif
	if	bits==17
name\_w	set	$0020C0
	endif
	if	bits==18
name\_w	set	$002060
	endif
	if	bits==19
name\_w	set	$0800F0
	endif
	if	bits==20
name\_w	set	$000098
	endif
	if	bits==21
name\_w	set	$00002C
	endif
	if	bits==22
name\_w	set	$00000E
	endif
	if	bits==23
name\_w	set	$000403
	endif
	if	bits==24
name\_w	set	$020007
	endif
	
	coef	name\_wght,name\_w
	coef	name\_b0,1<<(24-bits)
	var	name\_sr,0

	section		inits
	org	p:
	move	#$800000,a1
	sta1	name\_sr
	endsec

	lda		name\_sr
	lsl		a	y:name\_wght,x0
	eor		x0,a		ifcs
	sta1		name\_sr
	move		a1,a
	bchg		#6,a2
	sta		name
	
	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


