;; Sine wave generator, frequency modulable  y(k) = sin(2*pi*freq*k/Fs)
;; Syntax:	g_sin	name,freq,abs|rel
;; where frequency is in Hz if 'abs' and relative to Fs/2 if 'rel'
;; Output: name 	Optional input: name_freq 	Optional output: name_phi
;;

g_sin	macro	name,freq,unit
	 if	("unit"=='abs')||("unit"=='Hz')
	coef	name\_freq,freq*2.0/actual_fs
	 else
	coef	name\_freq,freq
	 endif

	cn	name\_freq,name\_phi_freq
	cn	name\_phi,name\_fsin_in	
	cn	name\_fsin,name

	g_saw	name\_phi,freq,unit
	f_sin	name\_fsin,31


	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


