;; Manual console data input
;; Syntax:	man	name,max,unit
;; where name is a variable or parameter, max it's maximum (coded +1.0), and unit a description string (e.g. 'Volts')
;; Press <return> to view current parametrer. Press <decimal value> <return> to modify parameter
;; Press <Space> to access next parameter (Several "man" instructions may be used;)

man	macro	name,max,unit

	str	name\_s,"name"++' = '

	if	!@def(scrxbuf)
	buf	scrxbuf,y,15
	endif


	if	!@def(curman)
curman	set	0
	var	nman,0
	else
curman	set	curman+1
	endif


	cn	name,name\_d_in


	if	!@def(iniman)
	section	inits
	global iniman
iniman	flagclr	rxd
	bset	#11,x:scr		; RIE bit
	endsec
	endif

; 
	org	p:

name\_man_exe	
	jcnf	nxtman,name\_man_ex1
	lda	nman
	add	#1,a
	cmp	#nbman,a
	clr	a	ifgt
	sta	nman
	bra	name\_man_ex2	

name\_man_ex1
	lda	nman
	cmp	#curman,a
	bne	<name\_man_ex2
	jcnf	rxd,name\_man_ex2
	if	@cnt()>1
	val	name,scrxbuf,max
	else
	val	name,scrxbuf,1.0
	endif

name\_man_ex0
;	cn	name,in_d_\name

	if	@cnt()>1
	strd	name\_d,name\_s,8,max
	else
	strd	name\_d,name\_s,8,1.0
	endif

	if	@cnt()==3
	str	name\_s,"unit"
	endif

	strln	name\_s,''

	snds	name\_s		

name\_man_ex2




	if	!@def(irqrx)

	setirq	scrx,1,irqrx

	begint	irqrx

	ptr	prx,0,scrxbuf,-1,0
	movep	x:<<srxl,a
	and	#$7F,a
	move	a1,y:(r0)+
	cmp	#$20,a
	bne	<inrx1
	flagset	nxtman
;	bra	<inrx2
inrx1	cmp	#$20,a
	bgt	<inrx3
	flagset	rxd
inrx2	move	#scrxbuf,r0
	move	#13,a1
inrx3	movep	a1,x:<<stxl	
	ptru	prx
	u	a

	endint	irqrx


	endif

	endm

 
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


