;; Multiply 2 variables (real or complex) y = x1 * x2
;; Syntax:	mult	name
;; Note: The output must be complex connected if one of the inputs or both are complex  
;; Inputs: name_in1, name_in2   Output: name

mult	macro	name
	cc_rst
 if	@def(name\_in1_im)
  if	@def(name\_in2_im)

	ldx0	name\_in1_re
	ldx1	name\_in1_im

	ldy0	name\_in2_re
	ldy1	name\_in2_im

	mpy	x0,y0,a
	macr	-x1,y1,a
	mpy	x0,y1,b
	macr	x1,y0,b

	sta	name\_re
	stb	name\_im

	u	x
	u	y
	u	a
	u	b
  else
	ldx0	name\_in1_re
	ldx1	name\_in1_im
	ldy0	name\_in2
	mpyr	x0,y0,a
	mpyr	x1,y0,b	
	sta	name\_re
	stb	name\_im

	u	x
	u	y
	u	a
	u	b
  endif
 else
  if	@def(name\_in2_im)
	ldx0	name\_in2_re
	ldx1	name\_in2_im
	ldy0	name\_in1
	mpyr	x0,y0,a
	mpyr	x1,y0,b	
	sta	name\_re
	stb	name\_im

	u	x
	u	y
	u	a
	u	b
  else
	ldx0	name\_in1
	ldx1	name\_in2
	mpyr	x0,x1,a
	sta	name\_re

	u	a
	u	x

  endif
 endif
 	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


