;; Quantize data to n bits
;; Syntax:	quant name,bits,{e|r|d}
;; Method: e = excess    r = round to nearest   d = default
;; Input: name_in	Output: name
;; Quantize to n bits

quant	macro	name,bits,mode

	lda	name\_in
	if	"mode"=='e'
	add	#>$7FFFFF>>bits-1,a
	endif

	if	"mode"=='r'
	add	#>$400000>>bits-1,a
	endif
	
	and	#>$FFFFFF<<24-bits,a
	sta	name

	u	a
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


