;; Square root by successive approximations  y = x^(1/2)
;; Syntax:	sqroot	name
;; Output = 12 bit if input is 24b, output = 24 bit if input = double or register A 
;; Input: name_in	    Output: name

sqroot	macro	name
	org	p:
name\_exe
 if	rgin
	move	a,y1
	move	a0,y0
	clr	a	#0.5,x0
	move	x0,x1
	do	#24,name\_1

 else
  if	@msp(name\_in)==3
	ldy	name\_in
	clr	a	#0.5,x0
	move	x0,x1
	do	#24,name\_1
  else

	ldy1	name\_in
	move	#0,y0
	clr	a	#0.5,x0
	move	x0,x1
	do	#12,name\_1
  endif
 endif

	mpy	-x0,x0,b
	add	y,b
	tge	x0,a
	tfr	x1,b
	asr	b
	nop
	add	a,b	b,x1
	nop
	move	b,x0
name\_1
	sta	name

	u	a
	u	b
	u	x

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


