;; A-law to linear conversion
;; If code = g711, even bits inversion 

alawtolin   macro	name,code
	lda		name\_in
 if "code"=='G.711'
	eor     	#$550000,a
 endif
	move    	a,y1                   ;save input
	abs		a
	and		#$7F0000,a 
	asr		#20,a,b		; b1=0..7
	move		b1,b
	and		#$0F0000,a
	tst		b	#$100000,x0
	add		x0,a	ifgt
	add		#$008000,a
	lsr		#4,a
	cmp		#1,b
	ble		name\1
	sub		#1,b
	lsl		b1,a 
name\1
	move		a1,a
	btst		#23,y1
	neg		a	ifcs		
	sta		name


	u	a
	u	b
	u	x
	u	y


	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use

