;; Linear (n,k) encoder
;; Syntax: encode	name,n,k,'genmat.asm'
;; I/O = name_in, name (left justified)
;; input flag, output flag: name_in, name

blockcode	macro	name,n,k,g


	vecb		name\_in1,x,k
	vecb		name\_m,x,n

	cmatbc	name\_g,y,k,"g"

	cnm	name\_in1,name\_m_in1
	cnm	name\_g,name\_m_in2


	org	p:
	jnf		name\_ck,name\_1
	lda		name\_in
	lsr		#24-k,a
	sta1		name\_in1
	matmulb		name\_m,r
	lda		name\_m
	lsl		#24-n,a
	sta1		name
	flagset		name\_ready
name\_1
	endm



	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


