;; Noise resistant Derivator 
;; Differentiator FIR
;; h(n) = G[(N-1)/2-n], n=0..N-1

derivate	macro name,size,cal,unit
 if	"unit"=='u/smp'
name\_g	set	12./(cal*@cvf(size*(size*size-1)))
 endif
  if	"unit"=='u/ms'
name\_g	set	12.*actual_fs/(1000.*cal*@cvf(size*(size*size-1)))
 endif
 if	"unit"=='u/s'
name\_g	set	12.*actual_fs/cal*@cvf(size*(size*size-1))
 endif


	section	far	global
name\_n 	set 0.

	org	y:
name\_coeffs
	dup	size
	dc	name\_g*((@cvf(size)-1)/2-name\_n)
name\_n	set	name\_n+1.
	endm
	endsec

	bufm	name\_states,x,size

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,size-1,,
	ptr	name\_c,4,name\_coeffs,-1,,	

	ldx0	name\_in

	clr	a	x0,x:(r0)-	y:(r4)+,y0
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	sta	name

	ptru	name\_s


; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	r4

	endm		
	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


