;; Codeur diffrentiel pour invariance par rotation de phase
;; Accumulation des symboles modulo bps bits 


diffcod	macro	name,bps
 if @def(name\_rdy_b)
	flagrst	name\_rdy
 endif

	jnot	name\_ck,name\_1
	lda	name\_in
	ldb	name
	move	#>$ffffff<<(24-bps),x0
	and	x0,a
	and	x0,b
	add	b,a
	and	x0,a
	add	#@pow(2.,-bps),a
	sta1	name
 if @def(name\_rdy_b)
	flagset	name\_rdy
 endif
name\_1
	dbgw	DIFFCOD
	dbg	name\_in
	dbg	name

	u	a
	u	b
	u	x
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


