;; Octal Differential PSK decoder
;; Input = table of 8 complex 
;; on ck do for i=0 to 7 do 
;;    out[i] = in(k)[i] * conj(in(k-1)[i]) 


diffdec8x3	macro	name 
	bufm	name\_last,l,8 
	org	p:
	jnot	name\_ck,name\_1
	move	#name\_in,r0
	move	#name,r1 
	move	#-1,m0
	move	m0,m1
	move	#name\_last,r2
	move	m0,m2
	do	#8,name\_1
	move	l:(r0)+,x
	move	l:(r2),y
	move	x,l:(r2)+
	mpy	x1,y1,a	; re*re
	mac	x0,y0,a	; -im*-im
	mpy	-x1,y0,b	; re*-im
	mac	x0,y1,b	; im*re
	move	ab,l:(r1)+
name\_1
	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r1
	u	r2
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use



