;;  DISPLAY_DB    Converts variable to dB, dB value  to string,  sends string to serial port every 0.5sec
;; Syntax:    display_db   name,prologue,epilogue
;; where prologue is string preceeding digits, epilogue follows digits
;; Inputs: name_in, name_ref


display_db	macro	name,ante,post
	if	@def(name\_ref)
	cn	name\_in,name\_dv_num
	cn	name\_ref,name\_dv_den
	cn	name\_dv,name\_db_in
	cn	name\_db,name\_cv_in
	else
	cn	name\_in,name\_db_in
	cn	name\_db,name\_cv_in
	endif

	if	@len("ante")>0
	str	name\_s,"ante"
	endif

	timerf	name\_tm,2.0,abs
	jcnf	name\_tm,name\_1

	if	@def(name\_ref)
	divide name\_dv
	endif
	decibel name\_db
	strd	name\_cv,name\_s,4,100.
	if	@len("post")>0
	strln	name\_s,"post"
	else
	strln	name\_s
	endif
	snds	name\_s
name\_1
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


