;;  DISPLAY_FRACT    Converts variable to string,  sends string to serial port every 0.5sec
;; Syntax:    display_fract   name,prologue,digits,epilogue,scaling_factor
;; where prologue is string preceeding digits, epilogue follows digits
;; scaling factor = number to display when input variable = 1
;; Input: name_in = variable to display


display_fract	macro	name,ante,digits,post,factor
	cn	name\_in,name\_cv_in

	if	@len("ante")>0
	str	name\_s,"ante"
	endif

	timerf	name\_tm,2.0,abs
	jcnf	name\_tm,name\_1
	strd	name\_cv,name\_s,digits,factor
	if	@len("post")>0
	strln	name\_s,"post"
	else
	strln	name\_s
	endif
	snds	name\_s
name\_1
	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


