;; Gnrateur de rampe dclench par le drapeau START
;; Syntaxe: 	g_ramp	name,slope,abs|rel
;; La sortie name vaut 0 au repos, et volue pendant la dure de l'acquisition 
;; La pente est exprime soit en absolu (um/s) soit en relatif (um/chantillon)
;; o um reprsente l'unit machine.
;; La saturation se produit lorsque name=1; name repasse  0 

g_ramp	macro	name,amp,slope,ar


	if	"ar"=='abs'
	coef	name\_slope,slope/actual_fs
	else
	coef	name\_slope,slope
	endif
	var	name\_int_in,0
	cn	name\_int,name


	jf	name\_start,name\_1
	clr	a
	sta	name\_int
	bra	name\_2
name\_1
	lda	name\_slope
	sta	name\_int_in
name\_2
	ldb	name
	add	b,a
	cmp	#amp,a
	jle	name\_3
	move	#>amp,a
	flagclr name\_start
name\_3
	sta	name	

	u	a
	endm 
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


