;; Gnrateur de rampe dclench par le drapeau START
;; Syntaxe: 	g_ramp	name,slope,abs|rel
;; La sortie name vaut 0 au repos, et volue pendant la dure de l'acquisition 
;; La pente est exprime soit en absolu (um/s) soit en relatif (um/chantillon)
;; o um reprsente l'unit machine.
;; La saturation se produit lorsque name=1; name repasse  0 




g_slope	macro	name,startval,endval,duration,unit
	if	"unit"=='sec'
	coefd	name\_inc,(endval-startval)/(duration*actual_fs)      ;          n=d/Te=d*Fe  c=(ev-sv)/n
	else
	coefd	name\_inc,(endval-startval)/duration
	endif

	jnf	name\_busy,name\_1
 if @def(name\_end_b)
	flagrst name\_end
 endif

	lda	name
	ldx	name\_inc
	add	x,a
	cmp	#>endval,a
 if endval>startval
	blt	name\_3
 else
	bgt	name\_3
 endif
	flagclr name\_busy
 if @def(name\_end_b)
	flagset name\_end
 endif
	bra	name\_end

name\_1
	jnot	name\_start,name\_2
	flagset name\_busy
 if @def(name\_end_b)
	flagclr name\_end
 endif

name\_2
	jnot	name\_rst,name\_end
	move	#>startval,a
name\_3
	sta	name	
name\_end
	u	a
	u	x
	endm 
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


