;; Fixed real gain    y(k) = G * x(k) (abs value of G may be greater than 1)
;; Syntax:	gain    name,value
;; Combines multiply and shift to achieve range and precision
;; Input: name_in   Output: name
;; 

gain 	macro	name,gn

	org	p:
name\_rg	set		@cvi(@cel(@log(@abs(gn))/@log(2.)))
name\_fr	set		gn/@pow(2.0,name\_rg)

name\_exe

 if	gn==1.0
		lda		name\_in
 else
  if	gn==2.0
		lda		name\_in
		asl		a
  else
   if	gn==0.5
		lda		name\_in
		asr		a
   else
    if	 name\_fr==1.0
		lda		name\_in
     if  name\_rg>0
    		asl		#name\_rg,a,a
     else
		asr		#-name\_rg,a,a
     endif
    else
		u	x
     if	@abs(gn)>1
		ldx0		name\_in
		mpyri		#name\_fr,x0,a
		asl		#name\_rg,a,a
     else
		ldx0		name\_in
		mpyri		#gn,x0,a
     endif
    endif
   endif
  endif
 endif
	sta	name
	u	a
	u	x	
	endm	

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


