;; Polyphonic guitar
;;

guitpoly2	macro	name,chan,size 
_flag		set	0
_note		set	1
_freq		set	2
_vol		set	3
_transi	set	4
_frdyn 	set	5 
_saw		set	6
_envel 	set	7
_wave		set	8 
_out		set	9


	buf	name\_buf,x,10*size	; NB: 10 notes simultanes 
	var	name\tbr,0

	section	inits
	move	#name\_buf,r1
	move	#-1,m0
	clr	a
	rep	#10*size
	move	a,x:(r1)+
	endsec 
 if !@def(fnd_free)
	section	routines
	global	fnd_free
fnd_free
	move		#size-1,r3
	move		#-1,m4
	move		m4,m3
fnd_free0
	btst		#23,x:(r4)
	bcc		fnd_free1
	move		(r4)+n4
	move		(r3)-
	btst		#23,r3
	bcc		fnd_free0
fnd_free1
	rts
	endsec 
 endif 

 if !@def(fnd_note)
	section	routines
	global	fnd_note
fnd_note
	move		a,x1
	move		y:(r1+1),a
	move		#size-1,r3
fnd_note0
	move		x:(r4+1),x0
	cmp		x0,a
	beq		fnd_note1
	move		(r4)+n4
	btst		#23,x:(r4)
	bcc		fnd_free1
	move		(r4)+n4
	move		(r3)-
	btst		#23,r3
	bcc		fnd_note0
fnd_note1
	move		x1,a
	rts
	endsec 
 endif 

 if !@def(guitwave)
	section	routines

	section 	far global
pts	set	123
dang	set	2.*pi/@cvf(pts-1)
ang	set	0.0
	org	y:

tbguit
	dup	pts
;	dc	0.37*@sin(ang)+0.17*@sin(2*ang)+0.09*@sin(3*ang)+0.06*@sin(4*ang)+0.04*@sin(5*ang)+0.045*@sin(6*ang)
	dc	0.5*@sin(ang)+0.2*@sin(2*ang)+0.1*@sin(3*ang)+0.1*@sin(5*ang)+0.05*@sin(7*ang)
ang	set	ang+dang
	endm
	endsec 

	global	guitwave
guitwave
	move	#tbguit,r0
	move	#-1,m0
	move	#>pts-1,x0

	asr	a	#0.5,y1
	add	y1,a			;; a = (x + 1.0) / 2



	move	a,y0			;; y0= unsigned in
	mpy	x0,y0,a		;; a = u_in*segmts
	lsl	a
	asr	a			;; a1 = int = k ; a0 = pos fract
	move	a1,n0			;; n0 = int(")	
	move	a0,x1			;; x1 = fract(")
	move	(r0)+n0		;; r0 = absc(yk)

	move	y:(r0)+,a		;; a  = Yk
	move	y:(r0),y1		;; y1 = Yk+1

	mac	x1,y1,a		a,y0	;; a  = yk +fract*yk+1    y0=yk
	macr	-x1,y0,a		;; a  = yk +fract*(yk+1 -yk)		
	rts
	endsec 
 endif 

	org	p:
	move		#midi_cmdlist+chan*40,r1
	move		#name\_buf,r4
	move		#-1,m1
	move		m1,m4 
	move		#4,n1
	move		#10,n4
	clr	b
name\0
	do		#10,name\2a
	move		r1,r2
	move		y:(r2),a
	bclr		#21,y:(r2)
	bclr		#23,y:(r2)+
	bcc		<name\2
name\1
	move		#name\_buf,r4	
	btst		#22,a1 
	bcs		<name\10
	bsr		fnd_note			; stop note 
	move		a1,x:(r4)
	bra		<name\2
name\10
	bsr		fnd_free			; START new note 
	move		a,x:(r4)+	y:(r2)+,a	; flags
	move		a,x:(r4)+	y:(r2)+,a	; note 
	move		a,x:(r4)+	y:(r2)+,a	; freq
	move		a,x:(r4)+	  		; vol   r4->transi
	move		#>$7FFFFF,a
	move		a,x:(r4)+			; transitoire r4->frdyn
	move  	(r4)+ 			; r4->saw
	move		(r4)+				; r4->envel
	move		a,x:(r4)			; enveloppe  
name\2
	nop 
	move		(r1)+n1
	nop 
name\2a	 

	move		#name\_buf,r4
	do		#size,name\5
;	btst		#22,x:(r4)
;	bcs		<name\2a
;	bsr		fnd_note
;	bclr		#23,x:(r4)
;name\2a
	btst		#23,x:(r4)
	bcc		name\4
	move		x:(r4+_frdyn),x0			; freq
	move		x:(r4+_saw),a
	add		x0,a		
	move		a1,x:(r4+_saw)			; saw
;	sta		name\_saw
	bec		name\3
	move		x:(r4+_envel),x0			; chaque priode decay
	btst		#22,x:(r4)
	bcs		<name\20
	move		#0.7,x1
	bra		<name\21
name\20
	move		#>0.985,x1
name\21
	mpy		x0,x1,a
	move		a,x:(r4+_envel)
	cmp		#0.05,a			; si enveloppe <0.1 librer l'instr 
	bgt		name\3
	bclr		#23,x:(r4)
name\3
	move		x:(r4+_transi),x0
	mpyi 		#>0.9,x0,a
	move		a,x:(r4+_transi)

	move		x:(r4+_freq),a
	move		#>0.2,x1
	mac		x0,x1,a
	move		a,x:(r4+_frdyn)


	move		x:(r4+_saw),a
	bsr		guitwave
	move		a,x:(r4+_wave)			; waveform
	move		a,x0
	move		x:(r4+_vol),x1
	mpyr		x0,x1,a
	move		a,x0
	move		x:(r4+_envel),x1			; enveloppe 
	mpyr		x0,x1,a
	move		a,x:(r4+_out)			; output
	move		a,x0
	add		x0,b			; sum of outputs				
name\4
	move		(r4)+n4
	nop 
	nop
	nop	 
name\5 
	stb		name 
name\6
	u	a
	u	b
	u	r1
	u	n1 
	u	r4 
	u	n4
	u	r3
	endm
 






