;; (Slow) Inverse Discrete Fourier Transform
;; x(k) = Sigma(X(n)*exp(j*2*pi*n*k/N)) n=0..N-1
;;

idft		macro	name
n		set		name\_in_size

idftn	macro	name,n	;; Embedded mac: astuce pour transformer n en chane 
 if	!@def(dft_coeffs\?n)
; Sine-Cosine Table
		section	longfar	global	
angle	set	0.0
incr		set	2*pi/@cvf(n)
		org	l:
		buffer	r,n
dft_coeffs\?n
		dup	n
		dc	@lng(@frc(@cos(angle)),@frc(@sin(angle)))
angle	set	angle+incr
		endm
		endbuf		
		endsec
 endif

 if @def(name\_busy_b)
	flagset	name\_busy
 endif
	move		#name\_in,r0
	move		#n-1,m0
	move		#n,n0
;;	move		#dft_coeffs\?n,r4
	move		m0,m4
	move		#0,r5
	move		#-1,m5
	move		#name,n5
	do		n0,name\_2
	move		#name\_in,r0
	clr		a	#dft_coeffs\?n,r4
	clr		b		r5,n4
	move		x:(r0),x0	; x0=re
	move		y:(r0)+,y0	; y0=im
	move		y:(r4),y1	; y1=sin
	move		x:(r4)+n4,x1	; x1=cos
	do		n0,name\_1
	mac		x0,x1,a		; a=re*cos	
	mac		-y0,y1,a		; -im*sin
	mac		x0,y1,b		x:(r0),x0	y:(r4),y1	; b=re*sin
	mac		x1,y0,b		x:(r4)+n4,x1	 y:(r0)+,y0	; +im*cos
name\_1
	move		ab,l:(r5+n5)
	move		(r5)+
name\_2
	nop
 if @def(name\_busy_b)
	flagclr	name\_busy
 endif
	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0
	u	r4
	u	n4
	u	r5
	u	n5
	endm

	idftn		name,n
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


