;; Analog integrator  H(p)= g/p  --> Tg(z+1)/2(z-1)
;; syntax:	intega	name
;; input: name_in   output: name


intega	macro	name,gain
	vard	name\_last,0

 if @def(name\_clear) 
	jnot	name\_clear,name\_1
	clr		a
	sta		name\_last
	sta		name
name\_1
 endif  
	lda	name\_last
	ldx0	name\_in
	move	#>(gain/(2.*actual_fs)),x1
	mac	x0,x1,a	a,b
	sta	name\_last
	add	b,a
	sta	name


	u	a
	u	b
	u	x
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


