;; LOOKUP
;; Read data in memory
;; Field can be X:, Y:, L:, or P:
;; Input gives address; Output may be single or double.

lookup	macro	name
 if (name\_mem_col==1)||(!@def(name\_column))
	lda	name\_line
 else
  if (name\_mem_col==name\_mem_size)||(!@def(name\_line))
	lda	name\_column
  else
	ldx0	name\_line
	move	#>name\_mem_col,x1
	mpy	x0,x1,a
	asl	#23,a,a
	ldx0	name\_column
	add	x0,a
  endif
 endif
	add	#>name\_mem,a
	move	a1,r0
	nop
 if	@msp(name\_mem)==1
	move	x:(r0),a
 else 
  if	@msp(name\_mem)==2
	move	y:(r0),a
  else
   if	@msp(name\_mem)==3
	move	l:(r0),a
   else
    if @msp(name\_mem)==4
	move	p:(r0),a
    else 
	fail	'Memory field not defined'
    endif
   endif
  endif
 endif
	sta	name
	u	r0
	u	a
	endm
