;; Analog 1st order LP  H(p) = g/(1 +tau.p)  -->  H(z) = g1(1+z^-1) / (1 - g2.z^-1)
;; syntax:	lp1a	name,tau,gain
;; input: name_in   output: name


lp1a	macro	name,tau,gain
	var	name\_last,0

name\_g1	set	gain/(1.+2*tau*actual_fs)
name\_g2	set	(2*tau*actual_fs-1.)/(2*tau*actual_fs+1.)

	ldx0	name\_in
	move	#>name\_g1,x1
	mpy	x0,x1,a	x:name\_last,x0
	move	#>name\_g2,x1
	macr	x0,x1,a
	add	x0,a	a,x:name\_last	
	sta	name

	dbgw	LP1A
	dbg	name\_in
	dbg	name

	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


