;; Add 1 Weighted input (filter primitive)
;; madd name,gin
;; name_in, name_in1 = inputs
;; name = output = (name_in + gin*name_in1)
;; gain gin may be >1 or <-1, but output must stay between [-1..+1[

madd 	macro	name,gin	
name\_rg	set	0
 if	(@abs(gin)>1.0)
name\_rg	set		@cvi(@cel(@log(@abs(gin))/@log(2.)))
 endif
name\_sh	set	name\_rg
 if (name\_sh>0)
name\_fr	set   gin/@pow(2.0,name\_sh)
	coef	name\_k,name\_fr

	ldx0	name\_in1
	ldx1	name\_k
	mpy	x0,x1,a	y:name\_in,b
  if	name\_sh==1
	addl	b,a
  else
	asl	#name\_sh,a,a
	add	b,a
  endif
  u  b
 else
	lda	name\_in
  if	@abs(gin)!=1.0
	coef	name\_gin,gin
  endif
  if	@abs(gin)==1.0
	ldx0	name\_in1
   if gin>0
	add	x0,a	
   else
	sub	x0,a	
   endif
  else
	ldx0	name\_in1	
	ldx1	name\_gin
	mac	x0,x1,a
  endif	
 endif
 	sta	name
	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


