;; Matrix multiplication in GF(2)
;; M3[i,k]=Sigma{M1[i,j]M2[j,k], j=0..cols(M1)} mod 2
;; in memory: 1 line = 1 word; nth col = nth bit of word

matmulb	macro	name
	if	name\_in1_col!=name\_in2_lin
	fail	'Matrix1 columns should be equal to matrix2 lines'
	else
	move		#-1,m0
	move		m0,m1
	move		m0,m2
	move		m0,m3
	move		#name\_in1,r0
	move		#name\_in2,r1
	move		#name,r2
 
	clr	a					; Au pralable:
	rep	#name\_in1_lin			; RAZ matrice rsultat
 if	@msp(name)==1
	move	a,x:(r2)+				;
 else
  if	@msp(name)==2
	move	a,y:(r2)+
  else
   if	@msp(name)==3
	move	a,l:(r2)+
   endif
  endif
 endif

	move	#>1,x0					; sert  incrmenter B0
	clr	b	#0,x1				;
	move	#$00102F,b1				; B1[5..0] = position col(M2) et M3 (47 = 1st col)

	if	name\_in2_col>1			;
	do	#name\_in2_col,name\_3		; pour k= colonnes(M2)-1 .. 0
	endif
	move	#name\_in1,r0
	move	#name,r2				; x:(r0) = 1st row of name_in1, k bits
	if name\_in1_lin>1				;
	do	#name\_in1_lin,name\_2		; pour i= 0.. lignes(M1)-1
	endif

	move	#$00102F,r3				; R1[5..0]  = col(M1) = b47 (col0)
	move	#name\_in2,r1				; j=0
	move	#0,b0					; s=0
 
	if	name\_in1_col>1			; pour j=col(M1)-1 .. 0 
	do	#name\_in1_col,name\_1		;
	endif						;


 if	@msp(name\_in1)==1				;
	move	x:(r0),a				; A0 ou A10 = M1[i,.]
 else
  if	@msp(name\_in1)==2
	move	y:(r0),a
  else
   if	@msp(name\_in1)==3
	move	l:(r0),a
   endif
  endif
 endif
	
	move		r3,y0
	move		(r3)-
 	extract	y0,a,a
 if	@msp(name\_in2)==1				;A = M2[j,.]
	move	x:(r1)+,a				; 
 else
  if	@msp(name\_in2)==2
	move	y:(r1)+,a	
  else
   if	@msp(name\_in2)==3
	move	l:(r1)+,a	
   endif
  endif
 endif				
	beq	<name\_0				; si M1[i,j]<>0
	extract b1,a,a				; alors test M2[j,k]
	add	x,b	ifne				; si <>0 alors inc B0
name\_0
	nop	
name\_1						; fin j=0.. col(M1)


 if	@msp(name)==1					;
	move	x:(r2),a				; A0 = M3[i,.]
	insert b1,b0,a				; A0[j] = B0[0] = somme [mod 2]
	move	a1,x:(r2)				;
 else
  if	@msp(name)==2
	move	y:(r2),a
	insert b1,b0,a
	move	a1,y:(r2)				
  else
   if	@msp(name)==3
	move	l:(r2),a
	insert b1,b0,a
	move	a10,l:(r2)				
   endif
  endif
 endif

	move	(r0)+					; fin ligne i; i:=i+1
	move	(r2)+
name\_2

	sub	x0,b					; Dcrmenter B1: col(M2) suivante  

name\_3
							; fin k= 0.. colonnes(M2)-1

	endif						; fin si col(1)=lin(2)
	u	a
	u	b
	u	x
	u	r0
	u	n0
	u	r4
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


