;; Offset and gain	y = c + g*x
;; Syntax offgain	name,offset,gain
;; Offset can be connected to and made variable 
;; gain may be >1; shorter code if gain is power of 2

offgain	macro	name,offset,gain

		coef	off,offset

		lda	name\_in
		ldx0	off
		add	x0,a

 if	@abs(gain)<1
		move		a,x0
		mpyri		#gain,x0,a
 else

name\_rg	set		@cel(@log(@abs(gain))/@log(2.))
name\_fr	set		gain/@pow(2.0,name\_rg)

  if	name\_fr<1.0
		move		a,x0
		mpyi		#name\_fr,x0,a
  endif
		asl		#@cvi(name\_rg),a,a
		rnd		a
 endif

		sta	name

		u	a
		u	x
		endm
 
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


