;; RS_FLIPFLOP
;; RS flip flop 
;; Applying TRUE to SET input results in output TRUE
;; Applying TRUE to RESET input results in output FALSE
;; If parameter "Dominant state" is "SET" then applying TRUE to both inputs results in TRUE
;; Otherwise applying TRUE to both inputs results in FALSE

rs_flipflop	macro	name,dom
 if "dom"=='SET'
 	jnot		name\_set,name\_1
	flagset	name
	bra		<name\_2
name\_1	
	jnot		name\_rst,name\_2
	flagclr	name
name\_2
 else
 	jnot		name\_rst,name\_1
	flagclr	name
	bra		<name\_2
name\_1	
	jnot	name\_set,name\_2	
	flagset	name
name\_2
 endif
	endm
