;; Concatnation des symboles pour former des codes ASCII
;; Syntaxe: symrx   name,bps,sync
;; name_in = entre symbole (entier ou fraction)
;; name = sortie ASCII 
;; name_ck = validation d'chantillonnage (boolen)
;; bps = taille des symboles
;; Recalage sur le code 24 bits paramtrable "sync"


symtoasc	macro	name,bps,sync

	var 	name\_sampled,0
	var	name\_sr,0
	var	name\_syncsr,0
	var	name\_bits,0

	section	inits
	clr	a
	sta	name\_bits
	endsec



	org	p:

name\_exe
	flagrst 	name\_rdy
	jnot		name\_ck,name\_2

	clr	b	
	ldx0	name\_in
	if @def(name\_sampled)
	stx0	name\_sampled
	endif	

	move	#>$008000,y1
	move	#>sync,y0

	if	bps>1 
	do	#bps,name\_2
	endif

	move	x:name\_sr,b
	btst	#23,x0	
	add	y1,b	ifcs
	lsl	b	x0,a
	stb1	name\_sr

	ldb1	name\_syncsr
	lsl	a	
	rol	b	a1,x0
	and 	#$00FFFF,b
	stb1	name\_syncsr
	lda	name\_bits
	add	#1,a
	eor	y0,b
	clr	a	ifeq
	and	#7,a
	sta	name\_bits
	bne	name\_1
	lda	name\_sr
	sta	name
	flagset	name\_rdy
name\_1
	nop
	nop
name\_2

	u	a
	u	b
	u	x
	u	y

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


