;; Concatnation des symboles pour former des codes ASCII
;; Syntaxe: symrx   name,bps,sync
;; name_in = entre symbole (entier ou fraction)
;; name = sortie ASCII 
;; name_ck = validation d'chantillonnage (boolen)
;; bps = taille des symboles
;; Recalage sur le code 24 bits paramtrable "sync"


symtoascii	macro	name,bps,sync

syncwrd	equ	sync

	var	name,0
	var	name\_last,0
	var	name\_sr,0
	var	name\_samp,0
	var	name\_bits,$7fffff

	section	inits
	move	#$7FFFFF,a
	sta	name\_bits
	endsec



	org	p:

	dbgw	SYMRX
	dbgi	name\_in
	dbgf	name\_ck

 dbgdisa
name\_exe
	jcnf	name\_ck,name\_4
	clr	a
	ldx0	name\_sr
	lda0	name\_in
	sta0	name\_samp
	asl	#bps,a,a
	add	x0,a
	move	a1,a
	cmp	#>syncwrd,a
	beq	<name\_3
	ldb	name\_bits
	sub	#bps,b
	beq	<name\_1
	stb	name\_bits
	asl	#bps,a,a
	sta1	name\_sr
	bra	<name\_2
name\_1	sta	name
name\_3	move	#>24,b
	stb	name\_bits
 

name\_2
  if	@def(irqdma_txcom)
	jf	tx_busy,name\_4	; Dsactive la sortie si transmision VOSC en cours
  endif


	lda	name
	tst	a
	beq	<name\_4
	brclr	#1,x:ssr,name\_4

; if	"lr"=='l'
	asl	#8,a,a
	move	a2,x:stxl
	sta1	name

name\_4

	u	a
	u	b
	u	x

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


