; Tic Timer start
; Utility for H/W measuring effective execution time
; Tic = start 
; Toc = stop and display result  

tic	macro	timer,irq
	org	x:
	if	timer==0 
tcsrx	set	tcsr0
tcprx	set	tcpr0
tlrx	set	tlr0
tcrx	set	tcr0
	endif

	if	timer==1 
tcsrx	set	tcsr1
tcprx	set	tcpr1
tlrx	set	tlr1
tcrx	set	tcr1
	endif

	if	timer==2 
tcsrx	set	tcsr2
tcprx	set	tcpr2
tlrx	set	tlr2
tcrx	set	tcr2
	endif

	var	tic_time,0
	var	tic_sr,3
	org	p:
 if "irq"=='masked'	
	move sr,x:tic_sr
	ori	#3,mr
tic_irq_masked	equ	1
 endif 
	move	x:tcrx,a
	sta	tic_time

	section inits
	flagclr	tocdone
	move	#1000000,a
	do	a1,tictoc_init1
	nop
	nop
	nop
	nop
tictoc_init1
	movep	#0,x:tlrx
	movep	#$FFFFFF,x:tcprx
	movep	#0,x:tcprx
	movep	#$000001,x:tcsrx
	endsec
	u	a

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


