; Unmap
; input = a pair of coordinates from one constellation point
; output the corresponding code
; The whole table is scanned for searching the minimum distance

unmap	macro	name,bits,table

  	if	!@def(table)
	section	data global
	org	y:
table
	include	"table"++'.asm'
	endsec
 	endif

	org	p:

	move	#table,r0
	move	#>$7FFFFF,b
	ldx0	name\_in_re
 if @def(name\_in_im)
	ldx1	name\_in_im
 else
	move	#0,x1
 endif
	do	#1<<bits,name\_1

	mpy	x0,x0,a	y:(r0)+,y0	; A = inre	y0=sre
	mac	-x0,y0,a	x0,y1		; A-= inre*sre	y1= inre
	mac	-x0,y0,a	x1,x0		; A-= inre*sre	x0= inim
	mac	y0,y0,a	y:(r0)+,y0	; A+= sre		y0= sim

	mac	x0,x0,a			; A+=inim
	mac	-x0,y0,a			; A-=inim*sim
	mac	-x0,y0,a			; A-=inim*sim	
	mac	y0,y0,a	y1,x0		; A+=sim		x0=inre
	
	cmp	b,a
	tlt	a,b	r0,r4
name\_1 
	move	r4,a
	sub	#table+2,a
	lsr	a
	asr	#bits,a,a
	sta0	name

	u	a
	u	b	
	u	x
	u	y
	u	r4

	endm

	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


