;; Octal PSK8 unmapping 
;; Input = 8 complex values 
;; Output = 24b = 8*3b where 3b = position in constellation 


unmap8psk	macro	name
 if !@def(map8psk8)
	section	long	global
q	set	@frc(@sqt(0.5)) 
	org	l:
	buffer	m,8
map8psk8 
	dc	@lng($7FFFFF,0)
	dc	@lng(q,q) 
	dc	@lng(0,$7FFFFF)
	dc	@lng(-q,q) 
	dc	@lng($800001,0)
	dc	@lng(-q,-q)
	dc	@lng(0,$800001)
	dc	@lng(q,-q)
	endbuf 
	endsec 
 endif 
	org	p:
	flagrst	name\_rdy 
	jnot	name\_ck,name\_2
	move	#name\_in,r0
	move	#map8psk8,r1
	move	#-1,m0
	move	#7,m1
	do	#8,name\_1
	move	l:(r0)+,x
	move	#>$7FFFFF,y1
	do	#8,name\_0
	move	l:(r1),ab
	sub	x1,a
	sub	x0,b		a,y0
	mpy	y0,y0,a	b,y0
	mac	y0,y0,a
	asr	a		y1,b
	cmpm	y1,a
	tlt	a,b		r1,r4
	move	b,y1
	move	(r1)+ 
name\_0
	move	r4,a

	sub	#>map8psk8,a
	and	#7,a 	
	move	r2,b
	lsl	#3,b 
	add	b,a 
	move	a1,r2
name\_1
	sta1	name
	flagset	name\_rdy
name\_2

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r1
	u	r2
	u	r4
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


 	
