;; VECT_POW  Power of a real or complex vector
;; y[i] = average(|x[i]|)

vect_pow	macro		name
	move	#name\_in,r0
	move	#-1,m0
	move	#name,r4
	move	m0,m4
	move	#>0.001,y0
	move	#>0.999,y1
	do	#name\_size,name\_1

 if @msp(name\_in)==2
	move	y:(r0)+,x0
  if @msp(name)==2
	mpy	x0,x0,b	y:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,y:(r4)+
  else
	mpy	x0,x0,b	x:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,x:(r4)+
  endif
 endif
 if	@msp(name\_in)==1
	move	x:(r0)+,x0
  if @msp(name)==2
	mpy	x0,x0,b	y:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,y:(r4)+
  else
	mpy	x0,x0,b	x:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,x:(r4)+
  endif
 endif
 if	@msp(name\_in)==3	; Complex
	move	l:(r0)+,x
  if @msp(name)==2
	mpy	x0,x0,b	x1,x0
	mac	x0,x0,b	y:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,y:(r4)+
  else
	mpy	x0,x0,b	x1,x0
	mac	x0,x0,b	x:(r4),x1
	mpy	x1,y1,a	b,x0
	macr	x0,y0,a
	move	a,x:(r4)+
  endif
 endif
name\_1

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r4
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


