;; Reserve a modulo (size) buffer
;; Syntax:	bufm	name,field,size
;; where field can be x or y or l or p
;; Filled with with 0 at program init
;; JMO  Rev 27-10-04

bufm	macro	name,field,size

name\_size	equ	size
name\_sect	set		3
 if ("field"=='l')||("field"=='L')
	section longfar global
 else
	section far	global
 endif
	org	field:
	buffer	m,size
name	ds	size
	endbuf
	endsec

	section	inits
	move	#name,r0
	move	#-1,m0
	move	#size,n0
	clr	a
	rep	n0
	move	a,field:(r0)+
	endsec

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


