;; Create a complex coefficient in y: field
;; Syntaxes:
;; coefc name,ro,alpha,p   	= Polar form: alpha expressed in half turns (alpha = [-1..+1[)
;; coefc name,re,im,c		= Cartesian form
;; JMO REV 9/11/05 

coefc	macro	name,u,v,w
 if	!@def(name)
   if	"w"=='p'
	coef	name\_re,u*@cos(v*pi)
	coef	name\_im,u*@sin(v*pi)
   else
	coef	name\_re,u
	coef	name\_im,v
   endif
 endif		; def(nam)
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 20/09/2012

