;; Copy <size> last elements from source buffer to destination buffer
;; Syntax: copywin sbuf,dbuf,size
;; Substract the DC component
;; Weight them with a Blackman-Harris window

copywin	macro	sbuf,dbuf,size
	section	vars local
	org	y:
dc_\sbuf	ds	1
	endsec

	winbh	win_\dbuf,size

;	section exec
	move	y:wrptr_\sbuf,r1
	move	y:mod_\sbuf,m1
	move	#win_\dbuf,r4
	move	#-1,m4
	move	#dbuf+size-1,r5
	move	m4,m5
	move	#0,x1
	move	#>0.00001,y1
	move	y:dc_\sbuf,b
	

	do	#size,_copywin1
	move		x:(r1)-,a
	sub	b,a	y:(r4)+,y0
	move	a,x0
	mac	x0,y1,b	
	mpyr	x0,y0,a			x1,y:(r5)
	move	a,x:(r5)-
_copywin1
	move	b,y:dc_\sbuf
;	endsec
	
	endm
	
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 21/10/2005

