;; Load register Y from a 48 bit or 24 bit variable

ldy	macro	source
 if	@def(source\_accu)
	fail	"source",' is not accu-connectable'
 else
  if	@def(source)
   if	@msp(source)==3
	move	l:source,y
   endif
   if	@msp(source)==1
	move	x:source,y1
	move	#0,y0
	warn	"source",' is 24 bits instead of 48; LSBs set to 0 !'
   endif
   if	@msp(source)==2
	move	y:source,y1
	move	#0,y0
	warn	"source",' is 24 bits instead of 48; LSBs set to 0 !'
   endif
   
  else
	fail	"source",' is not connected !'
  endif
 endif
	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 21/10/2005

