;; Set IPRC or IPRP for getting interrupts
;; Unmask IPL to level
;; point vector to routine


setirq	macro	name,level,routine

	if	"name"=='irqa'
vector	set	$10
core	set	1
actb	set	0
	endif

	if	"name"=='irqb'
vector	set	$12
core	set	1
actb	set	3
	endif

	if	"name"=='irqc'
vector	set	$14
core	set	1
actb	set	6
	endif

	if	"name"=='irqd'
vector	set	$16
core	set	1
actb	set	9
	endif

	if	"name"=='dma0'
vector	set	$18
core	set	1
actb	set	12
	endif

	if	"name"=='dma1'
vector	set	$1A
core	set	1
actb	set	14
	endif

	if	"name"=='dma2'
vector	set	$1C
core	set	1
actb	set	16
	endif

	if	"name"=='dma3'
vector	set	$1E
core	set	1
actb	set	18
	endif

	if	"name"=='dma4'
vector	set	$20
core	set	1
actb	set	20
	endif

	if	"name"=='dma5'
vector	set	$22
core	set	1
actb	set	22
	endif
	

	if	"name"=='tcp0'
vector	set	$24
core	set	0
actb	set	8	
	endif

	if	"name"=='tov0'
vector	set	$26
core	set	0
actb	set	8	
	endif

	if	"name"=='tcp1'
vector	set	$28
core	set	0
actb	set	8	
	endif

	if	"name"=='tov1'
vector	set	$2A
core	set	0
actb	set	8	
	endif

	if	"name"=='tcp2'
vector	set	$2C
core	set	0
actb	set	8	
	endif

	if	"name"=='tov2'
vector	set	$2E
core	set	0
actb	set	8	
	endif

	if	"name"=='e0rx'
vector	set	$30
core	set	0
actb	set	2	
	endif

	if	"name"=='e0re'
vector	set	$32
core	set	0
actb	set	2	
	endif

	if	"name"=='e0rl'
vector	set	$34
core	set	0
actb	set	2	
	endif

	if	"name"=='e0tx'
vector	set	$36
core	set	0
actb	set	2	
	endif

	if	"name"=='e0te'
vector	set	$38
core	set	0
actb	set	2	
	endif

	if	"name"=='e0tl'
vector	set	$3A
core	set	0
actb	set	2	
	endif

	if	"name"=='e1rx'
vector	set	$40
core	set	0
actb	set	4	
	endif

	if	"name"=='e1re'
vector	set	$42
core	set	0
actb	set	4	
	endif

	if	"name"=='e1rl'
vector	set	$44
core	set	0
actb	set	4	
	endif

	if	"name"=='e1tx'
vector	set	$46
core	set	0
actb	set	4	
	endif

	if	"name"=='e1te'
vector	set	$48
core	set	0
actb	set	4	
	endif

	if	"name"=='e1tl'
vector	set	$4A
core	set	0
actb	set	4	
	endif

	if	"name"=='scrx'
vector	set	$50
core	set	0
actb	set	6	
	endif

	if	"name"=='scre'
vector	set	$52
core	set	0
actb	set	6	
	endif

	if	"name"=='sctx'
vector	set	$54
core	set	0
actb	set	6	
	endif

	if	"name"=='scid'
vector	set	$56
core	set	0
actb	set	6	
	endif

	if	"name"=='sctm'
vector	set	$58
core	set	0
actb	set	6	
	endif

	if	"name"=='hrdf'
vector	set	$60
core	set	0
actb	set	0	
	endif

	if	"name"=='htde'
vector	set	$62
core	set	0
actb	set	0	
	endif

	if	"name"=='hcmd'
vector	set	$64
core	set	0
actb	set	0	
	endif


	section	vectors	
	org	p:vector
	jsr	routine
	endsec
	
	section	inits
	if	core	
val_iprc	set	val_iprc|(level<<actb)
	else
val_iprp	set	val_iprp|(level<<actb)
	endif	

val_sr	set	val_sr&$fffcff

	endsec
		
	endm
	list

	
		





;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 14/11/2001

