;; 12 bit square root by successive approximations
;; data 2..48b dans A --> result 1..24b dans A
sqrt	macro	bits

	move	a,y1
	move	a0,y0
	clr	a	#0.5,x0
	move	x0,x1
	do	#bits,_sqrt1
	mpy	-x0,x0,b
	add	y,b
	tge	x0,a
	tfr	x1,b
	asr	b
	nop
	add	a,b	b,x1
	nop
	move	b,x0
_sqrt1
	u	a
	u	b
	u	x
	u	y
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 23/05/2002

