;; Block prologue in Debug mode
;; register core, block nr, and subblock level
;; register start time, then start block execution

dbgs	macro	name,nr,level      ;; core,nblock,level
	var	name\_tic_time,0

 if	!@def(tictoc_init)
	section inits
	global	tictoc_init
tictoc_init
	move	#1000000,a
	do	a1,tictoc_init1
	nop
	nop
	nop
	nop
tictoc_init1
	movep	#0,x:tlr1
	movep	#$FFFFFF,x:tcpr1
	movep	#0,x:tcpr1
	movep	#$000001,x:tcsr1
	endsec
 endif

	org	p:
	move	#>level,a
	ldx0	dbglevel
	cmp	x0,a
	bgt	name\_dbgs2
	tst	a
	bpl	_dbgs0
	clr	a
	sta	dbglevel
_dbgs0
	move	#nr,a1
	sta1	blocknr
 if	core==0
_dbgs1	bclr	#0,y:stepflag
	bcc	_dbgs1
 else
_dbgs1	bclr	#1,y:stepflag
	bcc	_dbgs1
 endif

	flagset	name\_dbg
	movep	x:tcr1,x:name\_tic_time
name\_dbgs2
	endm




;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 09/01/2013

