;; Allocate / reserve DMA channel
;; dmar

dmar	macro	name
 if	!rsvd_dma0
dma_\name	equ	0
dmavec_\name	equ	$18
diprc_\name	equ	12
dsr_\name	equ	DSR0
ddr_\name	equ	DDR0
dco_\name	equ	DCO0
dcr_\name	equ	DCR0
rsvd_dma0	gset	1
 else
  if	!rsvd_dma1
dma_\name	equ	1
dmavec_\name	equ	$1A
diprc_\name	equ	14
dsr_\name	equ	DSR1
ddr_\name	equ	DDR1
dco_\name	equ	DCO1
dcr_\name	equ	DCR1
rsvd_dma1	gset	1
  else
   if	!rsvd_dma2
dma_\name	equ	2
dmavec_\name	equ	$1C
diprc_\name	equ	16
dsr_\name	equ	DSR2
ddr_\name	equ	DDR2
dco_\name	equ	DCO2
dcr_\name	equ	DCR2
rsvd_dma2	gset	1
   else
    if	!rsvd_dma3
dma_\name	equ	3
dmavec_\name	equ	$1E
diprc_\name	equ	18
dsr_\name	equ	DSR3
ddr_\name	equ	DDR3
dco_\name	equ	DCO3
dcr_\name	equ	DCR3
rsvd_dma3	gset	1
    else
     if	!rsvd_dma4
dma_\name	equ	4
dmavec_\name	equ	$20
diprc_\name	equ	20
dsr_\name	equ	DSR4
ddr_\name	equ	DDR4
dco_\name	equ	DCO4
dcr_\name	equ	DCR4
rsvd_dma4	gset	1
     else
      if	!rsvd_dma5
dma_\name	equ	5
dmavec_\name	equ	$22
diprc_\name	equ	22
dsr_\name	equ	DSR5
ddr_\name	equ	DDR5
dco_\name	equ	DCO5
dcr_\name	equ	DCR5
rsvd_dma5	gset	1
      else	
       if	!rsvd_dma6
dma_\name	equ	6
dmavec_\name	equ	$24
diprc_\name	equ	24 		; // >24 indique IPRC1
dsr_\name	equ	DSR6
ddr_\name	equ	DDR6
dco_\name	equ	DCO6
dcr_\name	equ	DCR6
rsvd_dma6	gset	1
       else	
        if	!rsvd_dma7
dma_\name	equ	7
dmavec_\name	equ	$26
diprc_\name	equ	26 		; // dto
dsr_\name	equ	DSR7
ddr_\name	equ	DDR7
dco_\name	equ	DCO7
dcr_\name	equ	DCR7
rsvd_dma7	gset	1
        else	
        fail	'Not enough DMA channels available !'
        endif
       endif
      endif
     endif
    endif
   endif
  endif
 endif
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 31/10/2009

